# Master project

This code and thesis were written by Mii Erik Haugård and Kim Long Vu.
There are to folders, one for the feedforward network, and one for the RNN.

The data from Sportradar is not included in this folder, as it belongs to Sportradar.

Note! You need an API-key from Sportradar to generate the data set.
   
##For feedforward:

####Requirements:  

 - requests==2.20.1
 - tensorflow==1.12.0
 - numpy==1.15.4
 - xmltodict==0.12.0
 - matplotlib==3.0.2
 - beautifulsoup4==4.7.1
 - scikit_learn==0.21.2

####Generate data set

- Run gen_dataset_training.py to generate training set

- Run gen_dataset_test.py to generate test set. Append wanted time wanted time points to "intervals"

#### Tests

##### In betting_simulation.py:
- Run find_best_network_params() to test all the different network parameters. Returns list ordered by validation accuracy
 
- Run betting_sim_1() for Betting simulation 1

- Run betting_sim_2() for Betting simulation 2

- Run betting_sim_3() for Betting simulation 3

##### In calibration_and_confusion.py:

- Run this to generate the calibration plot and confusion matrix.

##For RNN:

####Requirements:  

 - xmltodict==0.12.0
 - requests==2.18.4
 - torch==0.4.1
 - numpy==1.14.3
 - matplotlib==2.2.2


####Generate data set

- Run gen_dataset_training.py to generate training set

- Run gen_dataset_test.py to generate test set

#### Tests

##### In network_rnn.py:
- Run find_best_network_params() to test all the different network parameters. Returns list ordered by validation accuracy
 
- Run betting_sim_1() for Betting simulation 1

- Run betting_sim_2() for Betting simulation 2

- Run betting_sim_3() for Betting simulation 3

- Run calibration() to generate the calibration values

