import requests
import csv
import operator
from datetime import datetime
from random import randint
from pathlib import Path
import pickle
from datetime import timedelta

key = ""

def write_csv(file_name,list):
    with open("C:/Users/Mii Erik/OneDrive/Dokumenter/Skole/Masteroppgave/master/" + file_name, "w", newline="") as csv_file:
        writer = csv.writer(csv_file)
        writer.writerows(list)

def expected_goals_in_remaining_time(time_played, home_team_id, away_team_id, home_table, away_table):
    total_home_matches = 0
    total_home_scored = [0, 0, 0]
    total_home_conceded = [0, 0, 0]

    home_table = home_table
    away_table = away_table

    for team in home_table:
        total_home_matches += team["matches"]
        total_home_scored[0] += team["scored_array"][0]
        total_home_conceded[0] += team["conceded_array"][0]
        total_home_scored[1] += team["scored_array"][1]
        total_home_conceded[1] += team["conceded_array"][1]
        total_home_scored[2] += team["scored_array"][2]
        total_home_conceded[2] += team["conceded_array"][2]

    avg_scored_home = [x / total_home_matches for x in total_home_scored]
    avg_conceded_home = [x / total_home_matches for x in total_home_conceded]

    total_away_matches = 0
    total_away_scored = [0, 0, 0]
    total_away_conceded = [0, 0, 0]

    for team in away_table:
        total_away_matches += team["matches"]
        total_away_scored[0] += team["scored_array"][0]
        total_away_conceded[0] += team["conceded_array"][0]
        total_away_scored[1] += team["scored_array"][1]
        total_away_conceded[1] += team["conceded_array"][1]
        total_away_scored[2] += team["scored_array"][2]
        total_away_conceded[2] += team["conceded_array"][2]

    avg_scored_away = [x / total_away_matches for x in total_away_scored]
    avg_conceded_away = [x / total_away_matches for x in total_away_conceded]

    for team in home_table:
        if team["id"] == home_team_id:
            home_team = team

    for team in away_table:
        if team["id"] == away_team_id:
            away_team = team

    home_avg_scored = [x / home_team["matches"] for x in home_team["scored_array"]]
    away_avg_scored = [x / away_team["matches"] for x in away_team["scored_array"]]

    home_avg_conceded = [x / home_team["matches"] for x in home_team["conceded_array"]]
    away_avg_conceded = [x / away_team["matches"] for x in away_team["conceded_array"]]

    home_attacking_strenght = [a/b for a,b in zip(home_avg_scored,avg_scored_home)]
    away_defensive_strength = [a/b for a,b in zip(away_avg_conceded,avg_conceded_away)]

    away_attacking_strenght = [a / b for a, b in zip(away_avg_scored, avg_scored_away)]
    home_defensive_strength = [a / b for a, b in zip(home_avg_conceded, avg_conceded_home)]

    expected_home_goals0 = home_attacking_strenght[0]*away_defensive_strength[0]*avg_scored_home[0]
    expected_away_goals0 = away_attacking_strenght[0]*home_defensive_strength[0]*avg_scored_away[0]

    expected_home_goals1 = home_attacking_strenght[1] * away_defensive_strength[1] * avg_scored_home[1]
    expected_away_goals1 = away_attacking_strenght[1] * home_defensive_strength[1] * avg_scored_away[1]

    expected_home_goals2 = home_attacking_strenght[2] * away_defensive_strength[2] * avg_scored_home[2]
    expected_away_goals2 = away_attacking_strenght[2] * home_defensive_strength[2] * avg_scored_away[2]

    if time_played < 31:
        time_left_period = 30 - time_played

        expected_home_this_period = (expected_home_goals0/30) * time_left_period
        expected_away_this_period = (expected_away_goals0/30) * time_left_period

        expected_goals_home = expected_home_this_period + expected_home_goals1 + expected_home_goals2
        expected_goals_away = expected_away_this_period + expected_away_goals1 + expected_away_goals2

    elif time_played < 61:
        time_left_period = 60 - time_played
        expected_home_this_period = (expected_home_goals1 / 30) * time_left_period
        expected_away_this_period = (expected_away_goals1 / 30) * time_left_period

        expected_goals_home = expected_home_this_period + expected_home_goals2
        expected_goals_away = expected_away_this_period + expected_away_goals2

    else:
        time_left_period = 90 - time_played

        expected_goals_home = (expected_home_goals2 / 30) * time_left_period
        expected_goals_away = (expected_away_goals2 / 30) * time_left_period

    return expected_goals_home, expected_goals_away

def get_xg(match_id, time):
    my_file = Path('C:/Users/Mii Erik/OneDrive/Dokumenter/Skole/Masteroppgave/master/data/understat_xg/' + match_id + ".txt")

    with open(my_file, "rb") as fp:  # Unpickling
        b = pickle.load(fp)

    xg_home = 0
    xg_away = 0
    for each in b["h"]:
        if int(each["minute"]) <= time:
            xg_home += float(each["xG"])
        else:
            break

    for each in b["a"]:
        if int(each["minute"]) <= time:
            xg_away += float(each["xG"])
        else:
            break
    return xg_home, xg_away

season_ids = ["54571", "55917", "55737", "54373", "55017"]

for season_id in season_ids:
    r = requests.get(
        url="https://api.sportradar.us/soccer-x3/eu/en/tournaments/sr:season:" + season_id + "/info.json?api_key=" + key)

    tournament_info = r.json()
    teams = tournament_info['groups'][0]['teams']
    home_table = []
    away_table = []
    for team in teams:
        to_list = {
            "id": team['id'],
            "name": team['name'],
            "abbreviation": team['abbreviation'],
            "matches": 0,
            "scored": 0,
            "scored_array": [0, 0, 0],
            "conceded": 0,
            "conceded_array": [0, 0, 0],
            "points": 0
        }
        home_table.append(to_list)
        away_table.append(to_list)

    url = "https://api.sportradar.us/soccer-x3/eu/en/tournaments/sr:season:"+season_id +"/schedule.json?api_key=" + key
    r = requests.get(url=url)
    data = r.json()

    match_ids_before_new_year = []
    match_ids_after_new_year = []

    league = data["tournament"]["name"]

    year = data["sport_events"][0]["season"]["year"].split("/")[0]
    new_year = datetime.strptime("20"+year+"-12-31", '%Y-%m-%d')
    stop_date = datetime.strptime("2019-03-01", '%Y-%m-%d')

    for match in data["sport_events"]:
        id = match["id"].split(":")[2]
        date = match["scheduled"][:-15]
        match_date = datetime.strptime(date, '%Y-%m-%d')

        if match["status"] == "closed":
            if match_date <= new_year:
                if id not in match_ids_before_new_year:
                    match_ids_before_new_year.append(id)
            elif new_year < match_date and match_date < stop_date:
                if id not in match_ids_after_new_year:
                    match_ids_after_new_year.append(id)

    for match_id in match_ids_before_new_year:
        r = requests.get(url="https://api.sportradar.us/soccer-x3/eu/en/matches/sr:match:" + match_id + "/timeline.json?api_key=" + key)

        data = r.json()

        home_team_id = data["sport_event"]["competitors"][0]["id"]
        away_team_id = data["sport_event"]["competitors"][1]["id"]

        for team in home_table:
            if home_team_id == team["id"]:
                home_team = team
                home_points = team["points"]

        for team in away_table:
            if team["id"] == away_team_id:
                away_team = team
                away_points = team["points"]

        match_summary = data["sport_event_status"]

        if "winner_id" in match_summary:
            if match_summary["winner_id"] == home_team_id:
                home_points += 3
            elif match_summary["winner_id"] == away_team_id:
                away_points += 3
            else:
                home_points += 1
                away_points += 1
        else:
            home_points += 1
            away_points += 1

        home_scored_array = [0, 0, 0]
        home_conceded_array = [0, 0, 0]

        away_scored_array = [0, 0, 0]
        away_conceded_array = [0, 0, 0]

        timeline = data["timeline"]

        for event in timeline:
            if event["type"] == "score_change":
                if event["team"] == "home":
                    if event["match_time"] < 31:
                        home_scored_array[0] += 1
                        away_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        home_scored_array[1] += 1
                        away_conceded_array[1] += 1
                    else:
                        home_scored_array[2] += 1
                        away_conceded_array[2] += 1
                elif event["team"] == "away":
                    if event["match_time"] < 31:
                        away_scored_array[0] += 1
                        home_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        away_scored_array[1] += 1
                        home_conceded_array[1] += 1
                    else:
                        away_scored_array[2] += 1
                        home_conceded_array[2] += 1

        home_update = {
            "id": home_team_id,
            "name": home_team["name"],
            "abbreviation": home_team["abbreviation"],
            "matches": home_team["matches"] + 1,
            "scored": home_team["scored"] + match_summary["home_score"],
            "scored_array": list(map(operator.add, home_scored_array, home_team["scored_array"])),
            "conceded": home_team["conceded"] + match_summary["away_score"],
            "conceded_array": list(map(operator.add, home_conceded_array, home_team["conceded_array"])),
            "points": home_points
        }

        for i, team in enumerate(home_table):
            if team["id"] == home_team["id"]:
                home_table[i] = home_update

        away_update = {
            "id": away_team_id,
            "name": away_team["name"],
            "abbreviation": away_team["abbreviation"],
            "matches": away_team["matches"] + 1,
            "scored": away_team["scored"] + match_summary["away_score"],
            "scored_array": list(map(operator.add, away_scored_array, away_team["scored_array"])),
            "conceded": away_team["conceded"] + match_summary["home_score"],
            "conceded_array": list(map(operator.add, away_conceded_array, away_team["conceded_array"])),
            "points": away_points
        }

        for i, team in enumerate(away_table):
            if team["id"] == away_team["id"]:
                away_table[i] = away_update

    data_set = []
    for match_id in match_ids_after_new_year:
        if match_id == "9540195" or match_id == "16553383" or match_id == "17503889" or match_id == "17487549":
            continue

        intervals = []
        #intervals.append(5)
        #intervals.append(10)
        #intervals.append(15)
        #intervals.append(20)
        #intervals.append(25)
        #intervals.append(30)
        #intervals.append(35)
        #intervals.append(40)
        #intervals.append(45)
        #intervals.append(50)
        #intervals.append(55)
        #intervals.append(60)
        #intervals.append(65)
        #intervals.append(70)
        #intervals.append(75)
        #intervals.append(80)
        #intervals.append(85)
        #intervals.append(90)
        intervals.append(randint(1, 90))


        url = "https://api.sportradar.us/soccer-x3/eu/en/matches/sr:match:" + match_id + "/timeline.json?api_key=" + key
        r = requests.get(url=url)
        data = r.json()

        # Checks that it's actaully a league match
        event_info = data["sport_event"]["tournament_round"]
        if "name" in event_info:
            print(event_info["@name"])
            continue

        event = data["sport_event"]
        home_team_id = event["competitors"][0]["id"]
        away_team_id = event["competitors"][1]["id"]

        match_start = datetime.strptime(data["timeline"][0]["time"][:-6], '%Y-%m-%dT%H:%M:%S')
        match_end = datetime.strptime(data["timeline"][-1]["time"][:-6], '%Y-%m-%dT%H:%M:%S')

        d = {}
        for inter in intervals:  # each interval
            bet_decided = match_end
            if inter < 46:
                time_at_interval = match_start + timedelta(minutes=(inter-1))
            else:
                for action in data["timeline"]:
                    if action["type"] == "period_start" and action["period"] == 2:
                        time_at_interval = datetime.strptime(action["time"][:-6], '%Y-%m-%dT%H:%M:%S') + timedelta(minutes=(inter-46))
                        break

            expected_goals_home, expected_goals_away = expected_goals_in_remaining_time(inter, home_team_id, away_team_id, home_table, away_table)

            home_score_changed = 0
            home_goal_kick = 0
            home_throw_in = 0
            home_shot_saved = 0
            home_shot_on_target = 0
            home_shot_off_target = 0
            home_free_kick = 0
            home_injury = 0
            home_corner_kick = 0
            home_offside = 0
            home_yellow_card = 0
            home_red_card = 0
            home_yellow_red_card = 0

            away_score_changed = 0
            away_goal_kick = 0
            away_throw_in = 0
            away_shot_saved = 0
            away_shot_on_target = 0
            away_shot_off_target = 0
            away_free_kick = 0
            away_injury = 0
            away_corner_kick = 0
            away_offside = 0
            away_yellow_card = 0
            away_red_card = 0
            away_yellow_red_card = 0

            home_score = 0
            tot_home_goal_kick = 0
            tot_home_throw_in = 0
            tot_home_shot_saved = 0
            tot_home_shot_on_target = 0
            tot_home_shot_off_target = 0
            tot_home_free_kick = 0
            tot_home_injury = 0
            tot_home_corner_kick = 0
            tot_home_offside = 0
            tot_home_yellow_card = 0
            tot_home_red_card = 0
            tot_home_yellow_red_card = 0

            away_score = 0
            tot_away_goal_kick = 0
            tot_away_throw_in = 0
            tot_away_shot_saved = 0
            tot_away_shot_on_target = 0
            tot_away_shot_off_target = 0
            tot_away_free_kick = 0
            tot_away_injury = 0
            tot_away_corner_kick = 0
            tot_away_offside = 0
            tot_away_yellow_card = 0
            tot_away_red_card = 0
            tot_away_yellow_red_card = 0

            next_goal = "none"

            int_start = 0
            if inter >= 15:
                int_start = inter - 15

            for action in data["timeline"]: #each action
                if "match_time" in action:
                    if action["match_time"] <= int_start:
                        if "team" in action:
                            if action["team"] == "away":
                                if action["type"] == "score_change":
                                    away_score += 1
                                elif action["type"] == "goal_kick":
                                    tot_away_goal_kick += 1
                                elif action["type"] == "throw_in":
                                    tot_away_throw_in += 1
                                elif action["type"] == "shot_saved":
                                    tot_away_shot_saved += 1
                                elif action["type"] == "shot_on_target":
                                    tot_away_shot_on_target += 1
                                elif action["type"] == "shot_off_target":
                                    tot_away_shot_off_target += 1
                                elif action["type"] == "free_kick":
                                    tot_away_free_kick += 1
                                elif action["type"] == "injury":
                                    tot_away_injury += 1
                                elif action["type"] == "corner_kick":
                                    tot_away_corner_kick += 1
                                elif action["type"] == "offside":
                                    tot_away_offside += 1
                                elif action["type"] == "yellow_card":
                                    tot_away_yellow_card += 1
                                elif action["type"] == "red_card":
                                    tot_away_red_card += 1
                                elif action["type"] == "yellow_red_card":
                                    tot_away_yellow_red_card += 1
                            else:
                                if action["type"] == "score_change":
                                    home_score += 1
                                elif action["type"] == "goal_kick":
                                    tot_home_goal_kick += 1
                                elif action["type"] == "throw_in":
                                    tot_home_throw_in += 1
                                elif action["type"] == "shot_saved":
                                    tot_home_shot_saved += 1
                                elif action["type"] == "shot_on_target":
                                    tot_home_shot_on_target += 1
                                elif action["type"] == "shot_off_target":
                                    tot_home_shot_off_target += 1
                                elif action["type"] == "free_kick":
                                    tot_home_free_kick += 1
                                elif action["type"] == "injury":
                                    tot_home_injury += 1
                                elif action["type"] == "corner_kick":
                                    tot_home_corner_kick += 1
                                elif action["type"] == "offside":
                                    tot_home_offside += 1
                                elif action["type"] == "yellow_card":
                                    tot_home_yellow_card += 1
                                elif action["type"] == "red_card":
                                    tot_home_red_card += 1
                                elif action["type"] == "yellow_red_card":
                                    tot_home_yellow_red_card += 1

                    elif int_start < action["match_time"] <= inter and not (action["match_time"] == 90 and "stoppage_time" in action):
                        if "team" in action:
                            if action["team"] == "away":
                                if action["type"] == "score_change":
                                    away_score_changed += 1
                                    away_score += 1
                                elif action["type"] == "goal_kick":
                                    away_goal_kick += 1
                                    tot_away_goal_kick += 1
                                elif action["type"] == "throw_in":
                                    away_throw_in += 1
                                    tot_away_throw_in += 1
                                elif action["type"] == "shot_saved":
                                    away_shot_saved += 1
                                    tot_away_shot_saved += 1
                                elif action["type"] == "shot_on_target":
                                    away_shot_on_target += 1
                                    tot_away_shot_on_target += 1
                                elif action["type"] == "shot_off_target":
                                    away_shot_off_target += 1
                                    tot_away_shot_off_target += 1
                                elif action["type"] == "free_kick":
                                    away_free_kick += 1
                                    tot_away_free_kick += 1
                                elif action["type"] == "injury":
                                    away_injury += 1
                                    tot_away_injury += 1
                                elif action["type"] == "corner_kick":
                                    away_corner_kick += 1
                                    tot_away_corner_kick += 1
                                elif action["type"] == "offside":
                                    away_offside += 1
                                    tot_away_offside += 1
                                elif action["type"] == "yellow_card":
                                    away_yellow_card += 1
                                    tot_away_yellow_card += 1
                                elif action["type"] == "red_card":
                                    away_red_card += 1
                                    tot_away_red_card += 1
                                elif action["type"] == "yellow_red_card":
                                    away_yellow_red_card += 1
                                    tot_away_yellow_red_card += 1
                            else:
                                if action["type"] == "score_change":
                                    home_score_changed += 1
                                    home_score += 1
                                elif action["type"] == "goal_kick":
                                    home_goal_kick += 1
                                    tot_home_goal_kick += 1
                                elif action["type"] == "throw_in":
                                    home_throw_in += 1
                                    tot_home_throw_in += 1
                                elif action["type"] == "shot_saved":
                                    home_shot_saved += 1
                                    tot_home_shot_saved += 1
                                elif action["type"] == "shot_on_target":
                                    home_shot_on_target += 1
                                    tot_home_shot_on_target += 1
                                elif action["type"] == "shot_off_target":
                                    home_shot_off_target += 1
                                    tot_home_shot_off_target += 1
                                elif action["type"] == "free_kick":
                                    home_free_kick += 1
                                    tot_home_free_kick += 1
                                elif action["type"] == "injury":
                                    home_injury += 1
                                    tot_home_injury += 1
                                elif action["type"] == "corner_kick":
                                    home_corner_kick += 1
                                    tot_home_corner_kick += 1
                                elif action["type"] == "offside":
                                    home_offside += 1
                                    tot_home_offside += 1
                                elif action["type"] == "yellow_card":
                                    home_yellow_card += 1
                                    tot_home_yellow_card += 1
                                elif action["type"] == "red_card":
                                    home_red_card += 1
                                    tot_home_red_card += 1
                                elif action["type"] == "yellow_red_card":
                                    home_yellow_red_card += 1
                                    tot_home_yellow_red_card += 1

                    elif inter <= action["match_time"]:
                        if "team" in action:
                            if action["type"] == "score_change":
                                if action["team"] == "away":
                                    next_goal = "away"
                                    bet_decided = datetime.strptime(action["time"][:-6], '%Y-%m-%dT%H:%M:%S')
                                elif action["team"] == "home":
                                    next_goal = "home"
                                    bet_decided = datetime.strptime(action["time"][:-6], '%Y-%m-%dT%H:%M:%S')
                                break

            xg_home, xg_away = get_xg(match_id, inter)

            set = [match_id, expected_goals_home, expected_goals_away,
                   xg_home, xg_away, home_score, away_score, home_score_changed,
                   away_score_changed, tot_home_goal_kick, tot_away_goal_kick, home_goal_kick, away_goal_kick,
                   tot_home_throw_in, tot_away_throw_in, home_throw_in, away_throw_in, tot_home_shot_saved,
                   tot_away_shot_saved, home_shot_saved, away_shot_saved,
                   tot_home_shot_on_target, tot_away_shot_on_target, home_shot_on_target, away_shot_on_target,
                   tot_home_shot_off_target, tot_away_shot_off_target,
                   home_shot_off_target, away_shot_off_target, tot_home_free_kick, tot_away_free_kick, home_free_kick,
                   away_free_kick, tot_home_injury, tot_away_injury,
                   home_injury, away_injury, tot_home_corner_kick, tot_away_corner_kick, home_corner_kick,
                   away_corner_kick, tot_home_offside, tot_away_offside,
                   home_offside, away_offside, tot_home_yellow_card, tot_away_yellow_card, home_yellow_card,
                   away_yellow_card, tot_home_red_card, tot_away_red_card,
                   home_red_card, away_red_card, tot_home_yellow_red_card, tot_away_yellow_red_card,
                   home_yellow_red_card, away_yellow_red_card, inter, time_at_interval, bet_decided, match_end, next_goal]
            d[inter] = set
        for key, value in d.items():
            data_set.append(value)

        for team in home_table:
            if home_team_id == team["id"]:
                home_team = team
                home_points = team["points"]

        for team in away_table:
            if team["id"] == away_team_id:
                away_team = team
                away_points = team["points"]

        match_summary = data["sport_event_status"]

        if "winner_id" in match_summary:
            if match_summary["winner_id"] == home_team_id:
                home_points += 3
            elif match_summary["winner_id"] == away_team_id:
                away_points += 3
            else:
                home_points += 1
                away_points += 1
        else:
            home_points += 1
            away_points += 1

        home_scored_array = [0, 0, 0]
        home_conceded_array = [0, 0, 0]

        away_scored_array = [0, 0, 0]
        away_conceded_array = [0, 0, 0]

        timeline = data["timeline"]

        for event in timeline:
            if event["type"] == "score_change":
                if event["team"] == "home":
                    if event["match_time"] < 31:
                        home_scored_array[0] += 1
                        away_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        home_scored_array[1] += 1
                        away_conceded_array[1] += 1
                    else:
                        home_scored_array[2] += 1
                        away_conceded_array[2] += 1
                elif event["team"] == "away":
                    if event["match_time"] < 31:
                        away_scored_array[0] += 1
                        home_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        away_scored_array[1] += 1
                        home_conceded_array[1] += 1
                    else:
                        away_scored_array[2] += 1
                        home_conceded_array[2] += 1

        home_update = {
            "id": home_team_id,
            "name": home_team["name"],
            "abbreviation": home_team["abbreviation"],
            "matches": home_team["matches"] + 1,
            "scored": home_team["scored"] + match_summary["home_score"],
            "scored_array": list(map(operator.add, home_scored_array, home_team["scored_array"])),
            "conceded": home_team["conceded"] + match_summary["away_score"],
            "conceded_array": list(map(operator.add, home_conceded_array, home_team["conceded_array"])),
            "points": home_points
        }

        for i, team in enumerate(home_table):
            if team["id"] == home_team["id"]:
                home_table[i] = home_update

        away_update = {
            "id": away_team_id,
            "name": away_team["name"],
            "abbreviation": away_team["abbreviation"],
            "matches": away_team["matches"] + 1,
            "scored": away_team["scored"] + match_summary["away_score"],
            "scored_array": list(map(operator.add, away_scored_array, away_team["scored_array"])),
            "conceded": away_team["conceded"] + match_summary["home_score"],
            "conceded_array": list(map(operator.add, away_conceded_array, away_team["conceded_array"])),
            "points": away_points
        }

        for i, team in enumerate(away_table):
            if team["id"] == away_team["id"]:
                away_table[i] = away_update

    league.replace(" ", "")
    home_table = sorted(home_table, key=operator.itemgetter('points'), reverse=True)
    away_table = sorted(away_table, key=operator.itemgetter('points'), reverse=True)
    with open("data/tables/" + league + str(year) + str(int(year)+1) + "home.csv", 'w', newline="") as f:  # Just use 'w' mode in 3.x
        w = csv.DictWriter(f, home_table[0].keys())
        w.writeheader()
        w.writerows(home_table)

    with open("data/tables/" + league + year + str(int(year)+1) +"away.csv", 'w', newline="") as f:  # Just use 'w' mode in 3.x
        w = csv.DictWriter(f, away_table[0].keys())
        w.writeheader()
        w.writerows(away_table)

    write_csv("data/"+ league + year + str(int(year)+1) + "_for_new_test_3.csv", data_set)
