import requests
import csv
import operator
from datetime import datetime
import xmltodict
from random import randint
from pathlib import Path
import pickle

key = "" #Sportradar API-key

def write_csv(file_name,list):
    with open("C:/Users/kim_1/Desktop/master/" + file_name, "w", newline="") as csv_file:
        writer = csv.writer(csv_file)
        writer.writerows(list)

def create_to_csv(file_name, list):
    with open(file_name, "w", newline="") as csv_file:
        writer = csv.writer(csv_file)
        writer.writerows(list)

def expected_goals_in_remaining_time(time_played, home_team_id, away_team_id, home_table, away_table):
    total_home_matches = 0
    total_home_scored = [0, 0, 0]
    total_home_conceded = [0, 0, 0]

    home_table = home_table

    away_table = away_table

    for team in home_table:
        total_home_matches += team["matches"]
        total_home_scored[0] += team["scored_array"][0]
        total_home_conceded[0] += team["conceded_array"][0]
        total_home_scored[1] += team["scored_array"][1]
        total_home_conceded[1] += team["conceded_array"][1]
        total_home_scored[2] += team["scored_array"][2]
        total_home_conceded[2] += team["conceded_array"][2]

    avg_scored_home = [x / total_home_matches for x in total_home_scored]
    avg_conceded_home = [x / total_home_matches for x in total_home_conceded]

    total_away_matches = 0
    total_away_scored = [0, 0, 0]
    total_away_conceded = [0, 0, 0]

    for team in away_table:
        total_away_matches += team["matches"]
        total_away_scored[0] += team["scored_array"][0]
        total_away_conceded[0] += team["conceded_array"][0]
        total_away_scored[1] += team["scored_array"][1]
        total_away_conceded[1] += team["conceded_array"][1]
        total_away_scored[2] += team["scored_array"][2]
        total_away_conceded[2] += team["conceded_array"][2]

    avg_scored_away = [x / total_away_matches for x in total_away_scored]
    avg_conceded_away = [x / total_away_matches for x in total_away_conceded]

    for team in home_table:
        if team["id"] == home_team_id:
            home_team = team

    for team in away_table:
        if team["id"] == away_team_id:
            away_team = team

    home_avg_scored = [x / home_team["matches"] for x in home_team["scored_array"]]
    away_avg_scored = [x / away_team["matches"] for x in away_team["scored_array"]]

    home_avg_conceded = [x / home_team["matches"] for x in home_team["conceded_array"]]
    away_avg_conceded = [x / away_team["matches"] for x in away_team["conceded_array"]]

    home_attacking_strenght = [a/b for a,b in zip(home_avg_scored,avg_scored_home)]
    away_defensive_strength = [a/b for a,b in zip(away_avg_conceded,avg_conceded_away)]

    away_attacking_strenght = [a / b for a, b in zip(away_avg_scored, avg_scored_away)]
    home_defensive_strength = [a / b for a, b in zip(home_avg_conceded, avg_conceded_home)]

    expected_home_goals0 = home_attacking_strenght[0]*away_defensive_strength[0]*avg_scored_home[0]
    expected_away_goals0 = away_attacking_strenght[0]*home_defensive_strength[0]*avg_scored_away[0]

    expected_home_goals1 = home_attacking_strenght[1] * away_defensive_strength[1] * avg_scored_home[1]
    expected_away_goals1 = away_attacking_strenght[1] * home_defensive_strength[1] * avg_scored_away[1]

    expected_home_goals2 = home_attacking_strenght[2] * away_defensive_strength[2] * avg_scored_home[2]
    expected_away_goals2 = away_attacking_strenght[2] * home_defensive_strength[2] * avg_scored_away[2]


    if time_played < 31:
        time_left_period = 30 - time_played

        expected_home_this_period = (expected_home_goals0/30) * time_left_period
        expected_away_this_period = (expected_away_goals0/30) * time_left_period

        expected_goals_home = expected_home_this_period + expected_home_goals1 + expected_home_goals2
        expected_goals_away = expected_away_this_period + expected_away_goals1 + expected_away_goals2

    elif time_played < 61:
        time_left_period = 60 - time_played
        expected_home_this_period = (expected_home_goals1 / 30) * time_left_period
        expected_away_this_period = (expected_away_goals1 / 30) * time_left_period

        expected_goals_home = expected_home_this_period + expected_home_goals2
        expected_goals_away = expected_away_this_period + expected_away_goals2

    else:
        time_left_period = 90 - time_played

        expected_goals_home = (expected_home_goals2 / 30) * time_left_period
        expected_goals_away = (expected_away_goals2 / 30) * time_left_period

    return expected_goals_home, expected_goals_away

def get_xg(match_id, time):
    my_file = Path('C:/Users/kim_1/Desktop/master/data/understat_xg/' + match_id + ".txt")

    with open(my_file, "rb") as fp:  # Unpickling
        b = pickle.load(fp)

    xg_home = 0
    xg_away = 0
    for each in b["h"]:
        if int(each["minute"]) <= time:
            xg_home += float(each["xG"])
        else:
            break

    for each in b["a"]:
        if int(each["minute"]) <= time:
            xg_away += float(each["xG"])
        else:
            break
    return xg_home, xg_away

season_ids = ["54571"]
matches_after = []
for season_id in season_ids:
    r = requests.get(
        url="https://api.sportradar.us/soccer-x3/eu/en/tournaments/sr:season:" + season_id + "/info.json?api_key="+key)

    tournament_info = r.json()
    teams = tournament_info['groups'][0]['teams']
    home_table = []
    away_table = []
    for team in teams:
        to_list = {
            "id": team['id'],
            "name": team['name'],
            "abbreviation": team['abbreviation'],
            "matches": 0,
            "scored": 0,
            "scored_array": [0, 0, 0],
            "conceded": 0,
            "conceded_array": [0, 0, 0],
            "points": 0
        }
        home_table.append(to_list)
        away_table.append(to_list)

    url = "https://api.sportradar.us/soccer-x3/eu/en/tournaments/sr:season:"+season_id +"/schedule.json?api_key="+key
    r = requests.get(url=url)
    data = r.json()

    match_ids_before_new_year = []
    match_ids_after_new_year = []

    league = data["tournament"]["name"]

    year = data["sport_events"][0]["season"]["year"].split("/")[0]
    new_year = datetime.strptime("20"+year+"-12-31", '%Y-%m-%d')
    stop_date = datetime.strptime("2019-03-01", '%Y-%m-%d')

    for match in data["sport_events"]:
        id = match["id"].split(":")[2]
        date = match["scheduled"][:-15]
        match_date = datetime.strptime(date, '%Y-%m-%d')

        if match["status"] == "closed":
            if match_date <= new_year:
                if id not in match_ids_before_new_year:
                    match_ids_before_new_year.append(id)
            elif new_year < match_date and match_date < stop_date:
                if id not in match_ids_after_new_year:
                    match_ids_after_new_year.append(id)
    matches_after = matches_after + [[x] if x else None for x in match_ids_after_new_year]

    for match_id in match_ids_before_new_year:
        # This match was interupted
        print("getting match:"+match_id)
        r = requests.get(url="https://api.sportradar.us/soccer-x3/eu/en/matches/sr:match:" + match_id + "/timeline.json?api_key="+key)

        data = r.json()

        home_team_id = data["sport_event"]["competitors"][0]["id"]
        away_team_id = data["sport_event"]["competitors"][1]["id"]

        for team in home_table:
            if home_team_id == team["id"]:
                home_team = team
                home_points = team["points"]

        for team in away_table:
            if team["id"] == away_team_id:
                away_team = team
                away_points = team["points"]

        match_summary = data["sport_event_status"]

        if "winner_id" in match_summary:
            if match_summary["winner_id"] == home_team_id:
                home_points += 3
            elif match_summary["winner_id"] == away_team_id:
                away_points += 3
            else:
                home_points += 1
                away_points += 1
        else:
            home_points += 1
            away_points += 1

        home_scored_array = [0, 0, 0]
        home_conceded_array = [0, 0, 0]

        away_scored_array = [0, 0, 0]
        away_conceded_array = [0, 0, 0]

        timeline = data["timeline"]

        for event in timeline:
            if event["type"] == "score_change":
                if event["team"] == "home":
                    if event["match_time"] < 31:
                        home_scored_array[0] += 1
                        away_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        home_scored_array[1] += 1
                        away_conceded_array[1] += 1
                    else:
                        home_scored_array[2] += 1
                        away_conceded_array[2] += 1
                elif event["team"] == "away":
                    if event["match_time"] < 31:
                        away_scored_array[0] += 1
                        home_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        away_scored_array[1] += 1
                        home_conceded_array[1] += 1
                    else:
                        away_scored_array[2] += 1
                        home_conceded_array[2] += 1

        home_update = {
            "id": home_team_id,
            "name": home_team["name"],
            "abbreviation": home_team["abbreviation"],
            "matches": home_team["matches"] + 1,
            "scored": home_team["scored"] + match_summary["home_score"],
            "scored_array": list(map(operator.add, home_scored_array, home_team["scored_array"])),
            "conceded": home_team["conceded"] + match_summary["away_score"],
            "conceded_array": list(map(operator.add, home_conceded_array, home_team["conceded_array"])),
            "points": home_points
        }

        for i, team in enumerate(home_table):
            if team["id"] == home_team["id"]:
                home_table[i] = home_update

        away_update = {
            "id": away_team_id,
            "name": away_team["name"],
            "abbreviation": away_team["abbreviation"],
            "matches": away_team["matches"] + 1,
            "scored": away_team["scored"] + match_summary["away_score"],
            "scored_array": list(map(operator.add, away_scored_array, away_team["scored_array"])),
            "conceded": away_team["conceded"] + match_summary["home_score"],
            "conceded_array": list(map(operator.add, away_conceded_array, away_team["conceded_array"])),
            "points": away_points
        }

        for i, team in enumerate(away_table):
            if team["id"] == away_team["id"]:
                away_table[i] = away_update


    data_set = []
    for match_id in match_ids_after_new_year:
        if match_id == "9540195" or match_id == "16553383" or match_id == "17503889" or match_id == "17487549":
            continue
        url = "https://api.sportradar.us/soccer-x3/eu/en/matches/sr:match:"+match_id+"/timeline.json?api_key="+key
        r = requests.get(url=url)
        data = r.json()
        event = data["sport_event"]
        event_info = data["sport_event"]["tournament_round"]
        if "@name" in event_info:
            print(event_info["@name"])
            continue
        home_team_id = None
        away_team_id = None

        home_team_id = event["competitors"][0]["id"]
        away_team_id = event["competitors"][1]["id"]
        hold = []
        throwin_corner = False
        for i, action in enumerate(data["timeline"]):  # each action
            next_goal = "none"
            legal = False

            home_score_changed = 0
            home_goal_kick = 0
            home_throw_in = 0
            home_shot_saved = 0
            home_shot_on_target = 0
            home_shot_off_target = 0
            home_free_kick = 0
            home_injury = 0
            home_corner_kick = 0
            home_offside = 0
            home_yellow_card = 0
            home_yellow_red_card = 0
            home_red_card = 0
            home_penalty_awarded = 0
            home_penalty_missed = 0

            away_score_changed = 0
            away_goal_kick = 0
            away_throw_in = 0
            away_shot_saved = 0
            away_shot_on_target = 0
            away_shot_off_target = 0
            away_free_kick = 0
            away_injury = 0
            away_corner_kick = 0
            away_offside = 0
            away_yellow_card = 0
            away_yellow_red_card = 0
            away_red_card = 0
            away_penalty_awarded = 0
            away_penalty_missed = 0
            set = None
            if "match_time" in action:
                if action["match_time"] == 90 and "stoppage_time" in action:
                    continue
                egrt_home, egrt_away = expected_goals_in_remaining_time(
                    action["match_time"],
                    home_team_id,
                    away_team_id,
                    home_table,
                    away_table)
                if "team" in action:
                    if action["team"] == "away":
                        if action["type"] == "score_change":
                            legal = True
                            away_score_changed += 1
                        elif action["type"] == "goal_kick":
                            legal = True
                            away_goal_kick += 1
                        elif action["type"] == "throw_in":
                            throwin_corner = True
                            legal = True
                            away_throw_in += 1
                        elif action["type"] == "shot_saved":
                            legal = True
                            away_shot_saved += 1
                        elif action["type"] == "shot_on_target":
                            legal = True
                            away_shot_on_target += 1
                        elif action["type"] == "shot_off_target":
                            legal = True
                            away_shot_off_target += 1
                        elif action["type"] == "free_kick":
                            legal = True
                            away_free_kick += 1
                        elif action["type"] == "injury":
                            legal = True
                            away_injury += 1
                        elif action["type"] == "corner_kick":
                            legal = True
                            throwin_corner = True
                            away_corner_kick += 1
                        elif action["type"] == "offside":
                            legal = True
                            away_offside += 1
                        elif action["type"] == "yellow_card":
                            legal = True
                            away_yellow_card += 1
                        elif action["type"] == "yellow_red_card":
                            legal = True
                            away_yellow_red_card += 1
                        elif action["type"] == "red_card":
                            legal = True
                            away_red_card += 1
                        elif action["type"] == "penalty_missed":
                            legal = True
                            away_penalty_missed += 1
                        elif action["type"] == "penalty_awarded":
                            legal = True
                            away_penalty_awarded += 1
                    else:
                        if action["type"] == "score_change":
                            legal = True
                            home_score_changed += 1
                        elif action["type"] == "goal_kick":
                            legal = True
                            home_goal_kick += 1
                        elif action["type"] == "throw_in":
                            throwin_corner = True
                            legal = True
                            home_throw_in += 1
                        elif action["type"] == "shot_saved":
                            legal = True
                            home_shot_saved += 1
                        elif action["type"] == "shot_on_target":
                            legal = True
                            home_shot_on_target += 1
                        elif action["type"] == "shot_off_target":
                            legal = True
                            home_shot_off_target += 1
                        elif action["type"] == "free_kick":
                            legal = True
                            home_free_kick += 1
                        elif action["type"] == "injury":
                            legal = True
                            home_injury += 1
                        elif action["type"] == "corner_kick":
                            throwin_corner = True
                            legal = True
                            home_corner_kick += 1
                        elif action["type"] == "offside":
                            legal = True
                            home_offside += 1
                        elif action["type"] == "yellow_card":
                            legal = True
                            home_yellow_card += 1
                        elif action["type"] == "yellow_red_card":
                            legal = True
                            home_yellow_red_card += 1
                        elif action["type"] == "red_card":
                            legal = True
                            home_red_card += 1
                        elif action["type"] == "penalty_missed":
                            legal = True
                            home_penalty_missed += 1
                        elif action["type"] == "penalty_awarded":
                            legal = True
                            home_penalty_awarded += 1
                if legal:
                    for j, x in enumerate(data["timeline"]):
                        if j > i:
                            if "team" in x:
                                if x["type"] == "score_change":
                                    if x["team"] == "away":
                                        next_goal = "away"
                                    elif x["team"] == "home":
                                        next_goal = "home"
                                    break
                    xg_home, xg_away = get_xg(match_id, action["match_time"])
                    set = [action["match_time"],
                           egrt_home, egrt_away,
                           xg_home, xg_away,
                           home_score_changed, away_score_changed,
                           home_goal_kick, away_goal_kick,
                           home_throw_in, away_throw_in, home_shot_saved, away_shot_saved, home_shot_on_target,
                           away_shot_on_target,
                           home_shot_off_target, away_shot_off_target, home_free_kick, away_free_kick,
                           home_injury, away_injury, home_corner_kick, away_corner_kick, home_offside, away_offside,
                           home_yellow_card, away_yellow_card,
                           home_yellow_red_card, away_yellow_red_card,
                           home_red_card, away_red_card, home_penalty_awarded, away_penalty_awarded,
                           home_penalty_missed, away_penalty_missed,
                           next_goal,action["time"]]
                    hold.append(set)
        id_h,id_a = home_team_id.split(":")[2], away_team_id.split(":")[2]
        if id_h and id_a and throwin_corner:
            create_to_csv("./case_test/" + match_id + ".csv", hold)

        for team in home_table:
            if home_team_id == team["id"]:
                home_team = team
                home_points = team["points"]

        for team in away_table:
            if team["id"] == away_team_id:
                away_team = team
                away_points = team["points"]

        match_summary = data["sport_event_status"]

        if "winner_id" in match_summary:
            if match_summary["winner_id"] == home_team_id:
                home_points += 3
            elif match_summary["winner_id"] == away_team_id:
                away_points += 3
            else:
                home_points += 1
                away_points += 1
        else:
            home_points += 1
            away_points += 1
        home_scored_array = [0, 0, 0]
        home_conceded_array = [0, 0, 0]

        away_scored_array = [0, 0, 0]
        away_conceded_array = [0, 0, 0]

        timeline = data["timeline"]

        for event in timeline:
            if event["type"] == "score_change":
                if event["team"] == "home":
                    if event["match_time"] < 31:
                        home_scored_array[0] += 1
                        away_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        home_scored_array[1] += 1
                        away_conceded_array[1] += 1
                    else:
                        home_scored_array[2] += 1
                        away_conceded_array[2] += 1
                elif event["team"] == "away":
                    if event["match_time"] < 31:
                        away_scored_array[0] += 1
                        home_conceded_array[0] += 1
                    elif event["match_time"] < 61:
                        away_scored_array[1] += 1
                        home_conceded_array[1] += 1
                    else:
                        away_scored_array[2] += 1
                        home_conceded_array[2] += 1

        home_update = {
            "id": home_team_id,
            "name": home_team["name"],
            "abbreviation": home_team["abbreviation"],
            "matches": home_team["matches"] + 1,
            "scored": home_team["scored"] + match_summary["home_score"],
            "scored_array": list(map(operator.add, home_scored_array, home_team["scored_array"])),
            "conceded": home_team["conceded"] + match_summary["away_score"],
            "conceded_array": list(map(operator.add, home_conceded_array, home_team["conceded_array"])),
            "points": home_points
        }

        for i, team in enumerate(home_table):
            if team["id"] == home_team["id"]:
                home_table[i] = home_update

        away_update = {
            "id": away_team_id,
            "name": away_team["name"],
            "abbreviation": away_team["abbreviation"],
            "matches": away_team["matches"] + 1,
            "scored": away_team["scored"] + match_summary["away_score"],
            "scored_array": list(map(operator.add, away_scored_array, away_team["scored_array"])),
            "conceded": away_team["conceded"] + match_summary["home_score"],
            "conceded_array": list(map(operator.add, away_conceded_array, away_team["conceded_array"])),
            "points": away_points
        }

        for i, team in enumerate(away_table):
            if team["id"] == away_team["id"]:
                away_table[i] = away_update

    league.replace(" ", "")
    home_table = sorted(home_table, key=operator.itemgetter('points'), reverse=True)
    away_table = sorted(away_table, key=operator.itemgetter('points'), reverse=True)
    with open("new_data/tables_this_season/" + league + str(year) + str(int(year)+1) + "home.csv", 'w', newline="") as f:  # Just use 'w' mode in 3.x
        w = csv.DictWriter(f, home_table[0].keys())
        w.writeheader()
        w.writerows(home_table)

    with open("new_data/tables_this_season/" + league + year + str(int(year)+1) +"away.csv", 'w', newline="") as f:  # Just use 'w' mode in 3.x
        w = csv.DictWriter(f, away_table[0].keys())
        w.writeheader()
        w.writerows(away_table)
create_to_csv("case4_5_6_test_matches.csv", matches_after)

