import numpy as np
import torch
import torch.nn as nn
import matplotlib.pyplot as plt
import random
import os
import csv as csvv
from torch import optim
from datetime import datetime

class split_set():
    def __init__(self, divider, path, case):
        self.path = path
        self.x = []
        self.y = []
        self.names = []
        self.divider = divider
        self.case = case
        self.case_1_2_3_train = []
        self.case_4_5_6_train = []
        self.case_1_2_3_test = []
        self.case_4_5_6_test = []
        self.get_matche_ids()
        self.execute()
    def get_matche_ids(self):
        with open("case1_2_3_train_matches.csv", 'rU') as a:
            reader = csvv.reader(a)
            self.case_1_2_3_train = list(reader)
            self.case_1_2_3_train = [x[0] if x else None for x in self.case_1_2_3_train]

        with open("case4_5_6_test_matches.csv", 'rU') as a:
            reader = csvv.reader(a)
            self.case_4_5_6_test = list(reader)
            self.case_4_5_6_test = [x[0] if x else None for x in self.case_4_5_6_test]

        with open("case4_5_6_train_matches.csv", 'rU') as a:
            reader = csvv.reader(a)
            self.case_4_5_6_train = list(reader)
            self.case_4_5_6_train = [x[0] if x else None for x in self.case_4_5_6_train]

        with open("case1_2_3_test_matches.csv", 'rU') as a:
            reader = csvv.reader(a)
            self.case_1_2_3_test = list(reader)
            self.case_1_2_3_test = [x[0] if x else None for x in self.case_1_2_3_test]

    def execute(self):
        rootdir = self.path
        for files in os.walk(rootdir):
            random.shuffle(files[2])
            for file in files[2]:

                action = []
                label = []
                hold = []
                if self.case == 1 or self.case == 2 or self.case == 3:
                    if self.path == "C:/Users/kim_1/Desktop/master/case_test":
                        if file.split(".")[0] in self.case_1_2_3_test:
                            with open(rootdir.split("/")[5] + "/" + file, 'rU') as csvfile:
                                reader = csvv.reader(csvfile, delimiter=',')
                                action = list(reader)
                    else:
                        with open(rootdir.split("/")[5]+"/"+file, 'rU') as csvfile:
                            reader = csvv.reader(csvfile, delimiter=',')
                            action = list(reader)
                elif self.case == 4 or self.case == 5 or self.case == 6:
                    if self.path == "C:/Users/kim_1/Desktop/master/case_test":
                        if file.split(".")[0] in self.case_4_5_6_test:
                            with open(rootdir.split("/")[5]+"/"+file, 'rU') as csvfile:
                                reader = csvv.reader(csvfile, delimiter=',')
                                action = list(reader)
                    else:
                        if file.split(".")[0] in self.case_4_5_6_train:
                            with open(rootdir.split("/")[5]+"/"+file, 'rU') as csvfile:
                                reader = csvv.reader(csvfile, delimiter=',')
                                action = list(reader)
                for i in action:
                    if self.path == "C:/Users/kim_1/Desktop/master/case_test":
                        if i[-2] == "home":
                            label.append([float(1),float(0),float(0)])
                        elif i[-2] == "away":
                            label.append([float(0),float(0),float(1)])
                        else:
                            label.append([float(0),float(1),float(0)])
                        del i[-2]
                        del i[-1]
                    else:
                        if i[-1] == "home":
                            label.append([float(1), float(0), float(0)])
                        elif i[-1] == "away":
                            label.append([float(0), float(0), float(1)])
                        else:
                            label.append([float(0), float(1), float(0)])
                        del i[-1]
                    set = [float(j) for j in i]
                    if self.case == 1 or self.case == 4:
                        set = set[self.divider:]
                    if self.case == 2 or self.case == 5:
                        set = set[:5]
                    if self.case == 3 or self.case == 6:
                        set = [set[0]]+set[5:]

                    hold.append(set)
                if hold:
                    self.x.append(hold)
                    self.y.append(label)
                    self.names.append(file)
class network(nn.Module):
    def __init__(self, input_size, output_size, hidden_size, n_layers=2):
        super(network, self).__init__()
        self.hidden_size = hidden_size
        self.input_size = input_size
        self.num_layers = n_layers

        self.inp = nn.Linear(input_size , hidden_size )
        self.rnn = nn.LSTM(hidden_size, hidden_size, self.num_layers, dropout=0.3)
        self.out = nn.Linear(hidden_size, output_size)
        self.softmax = nn.Softmax(dim=1)

    def step(self, input, hidden=None):
        input = self.inp(input.unsqueeze(0))
        output, hidden = self.rnn(input, hidden)
        output = self.out(output.squeeze(0))
        output = self.softmax(output)
        return output, hidden

    def forward(self, inputs, hidden=None, output_tensor=None):
        output, hidden = self.step(inputs,hidden)
        return output, hidden
def train(dataset, epoch, crit="CE", lstm_layer = 2, hidden_size = 256, l_rate = 0.001, opt="adam"):

    x_tensor = []
    y_tensor = []
    for i, data in enumerate(dataset.x):
        x_tensor.append(torch.tensor(data))
        y_tensor.append(torch.tensor(dataset.y[i]))
    model = network(x_tensor[0].size()[1], y_tensor[0].size()[1], hidden_size,n_layers= lstm_layer)
    if crit == "MSE":
        criterion = nn.MSELoss()
    elif crit == "CE":
        criterion = nn.BCELoss()
    if opt == "adam":
        optimizer = optim.Adam(model.parameters(), lr=l_rate)
    elif opt == "sgd":
        optimizer = optim.sgd(model.parameters(), lr=l_rate)
    elif opt == "adagrad":
        optimizer = optim.adagrad(model.parameters(), lr=l_rate)

    x_train = x_tensor[:int(len(x_tensor) * .80)]
    y_train = y_tensor[:int(len(x_tensor) * .80)]
    losses = []
    validation_loss = []
    validation_accuracy = []
    best_acc = 0
    best_loss = 9999999999
    rounds = 0
    count_stopping_loss = 0
    before_stop_model = None
    for i in range(epoch):
        print("Epoch: "+str(i))
        loss_game = 0
        for j,data in enumerate(x_train):
            optimizer.zero_grad()
            output, hidden = model(data)
            loss = criterion(output, y_train[j])
            loss_game += loss.item()
            loss.backward()
            optimizer.step()
        acc, val_loss = validation(model, criterion, x_tensor, y_tensor)
        print(count_stopping_loss)
        if count_stopping_loss >= 5:
            print("STOPPING")
            label = []
            for i in range(rounds):
                label.append(i)

            f, axarr = plt.subplots(2, 1, sharex=True)
            axarr[0].set_title("Training values over epochs")
            axarr[0].plot(label, losses, '-o', label='Training loss')
            axarr[0].legend(loc=9, bbox_to_anchor=(0.5, -0.1), ncol=2)

            axarr[0].plot(label, validation_loss, '-o', label='Validation loss')
            axarr[0].legend(loc=9, bbox_to_anchor=(0.5, -0.1), ncol=2)

            axarr[1].plot(label, validation_accuracy, '-o', color="green", label='Validation accuracy')
            axarr[1].legend(loc=9, bbox_to_anchor=(0.5, -0.1), ncol=2)
            plt.tight_layout()
            plt.show()
            return before_stop_model, best_acc
        if val_loss < best_loss:
            before_stop_model = model
            best_loss = val_loss
            best_acc = acc
            count_stopping_loss = 0
        else:
            count_stopping_loss += 1
        losses.append(loss_game/len(x_train))
        validation_loss.append(val_loss)
        validation_accuracy.append(acc)
        rounds += 1
    label = []
    for i in range(rounds):
        label.append(i)

    f, axarr = plt.subplots(2, 1,sharex=True)
    axarr[0].set_title("Training values over epochs")
    axarr[0].plot(label, losses, '-o', label='Training loss')
    axarr[0].legend(loc=9, bbox_to_anchor=(0.5, -0.1), ncol=2)

    axarr[0].plot(label, validation_loss, '-o', label='Validation loss')
    axarr[0].legend(loc=9, bbox_to_anchor=(0.5, -0.1), ncol=2)

    axarr[1].plot(label, validation_accuracy, '-o', color="green", label='Validation accuracy')
    axarr[1].legend(loc=9, bbox_to_anchor=(0.5, -0.1), ncol=2)
    plt.xlabel("Epoch")
    plt.ylabel("Accuracy")
    plt.tight_layout()
    plt.show()

    return before_stop_model, best_acc
def test(rootdir_test,model,plot_prediction, dif_actions, print_value, baseline=False):
    case = int(model.split("_")[1])
    model = torch.load(model)
    model.eval()
    dataset_2 = split_set(divider=0, path=rootdir_test, case=case)
    names = dataset_2.names
    x_tensor = []
    y_tensor = []
    for i, data in enumerate(dataset_2.x):
        x_tensor.append(torch.tensor(data))
        y_tensor.append(torch.tensor(dataset_2.y[i]))
    test_x = x_tensor
    test_y = y_tensor
    #names = dataset.names
    each_game_acc = 0
    total_rounds = 0
    for i,data in enumerate(test_x):
      #  print(names[i] in dataset.names[:int(len(x_tensor) * .70)])
        internal_rounds = 0
        correct = 0
        output, hidden = model(data)
        previous_output = None
        home_predcition = []
        away_prediction = []
        none_prediction = []
        rounds = 0
        for j,x in enumerate(output):
            if data[j][0]:
                value = x.data
                home_predcition.append(value[0].item())
                none_prediction.append(value[1].item())
                away_prediction.append(value[2].item())
                if dif_actions:
                    if previous_output is None: #regne differansen av prediksjonene mellom hver handling
                        previous_output = value
                    else:
                        home_dif = abs(previous_output[0] - value[0])
                        none_dif = abs(previous_output[1] - value[1])
                        away_dif = abs(previous_output[2] - value[2])
                        if home_dif > dif_actions:
                            print(home_dif, none_dif, away_dif)
                        previous_output = value
                if print_value and names[i]=="14736763.csv":
                    print_set(data[j],value,test_y[i][j])
                _, indices = value.max(0)
                _, y_indices = test_y[i][j].max(0)
                if not baseline:
                    if y_indices.data.numpy() == indices.data.numpy():
                        correct += 1
                elif baseline == "home":
                    if y_indices.data.numpy() == 0:
                        correct += 1
                elif baseline == "egrt":
                    if data[j][1] > data[j][2] and y_indices.data.numpy() == 0:
                        correct += 1
                    elif data[j][1] < data[j][2] and y_indices.data.numpy() == 2:
                        correct += 1
                elif baseline == "xg":
                    if data[j][3] > data[j][4] and y_indices.data.numpy() == 0:
                        correct += 1
                    elif data[j][3] < data[j][4] and y_indices.data.numpy() == 2:
                        correct += 1

                internal_rounds += 1
                rounds += 1
        if plot_prediction and names[i]=="14736763.csv":
            label = []
            for j in range(rounds):
                label.append((j/rounds)*90)
            y = np.vstack([home_predcition,none_prediction,away_prediction])
            fig,ax = plt.subplots()
            ax.stackplot(label,home_predcition,none_prediction,away_prediction,labels =['Home','None','Away'], colors=['#1c4e80','#FFF222','#d32d41'])
            ax.set_xlim([0,89])
            ax.set_ylim([0,1])
            plt.legend(loc=0, bbox_to_anchor=(0.78, -0.13), ncol=3)
            plt.title("AFC Bournemouth - Wolverhampton Wanderers")
            plt.xlabel("Match Time")
            plt.ylabel("Probability")

            plt.show()
        total_rounds += 1
        each_game_acc += correct / internal_rounds
        if print_value and names[i]=="14736763.csv":
            print("-------------------------------------------------------------------------------------------------------------------------")
    print(each_game_acc/total_rounds)
def validation(model, criterion, x_tensor, y_tensor):
    model.eval()
    print("Validating")
    test_x = x_tensor[int(len(x_tensor) * .80):]
    test_y = y_tensor[int(len(x_tensor) * .80):]
    each_game_acc = 0
    total_rounds = 0
    losses = 0
    for i, data in enumerate(test_x): #For each game
        internal_rounds = 0
        correct = 0
        output, hidden = model(data)
        acc_output = model(data)
        for j, x in enumerate(acc_output[0]): #Calc accuracy for each game
            value = x.data
            _, indices = value.max(0)
            _, y_indices = test_y[i][j].max(0)
            if y_indices.data.numpy() == indices.data.numpy():
                correct += 1
            internal_rounds += 1
        loss = criterion(output, test_y[i])
        losses += loss.item()
        total_rounds += 1
        each_game_acc += correct / internal_rounds
    return each_game_acc/total_rounds, losses/len(test_x)
def betting_simulation(rootdir_test,rootdir_train, shuffle = True, bet_min = 45, case = 1, train_model= False, baseline=False):
    betting_mins = []
    for i in os.walk(rootdir_test):
        for file in i[2]:
            betting_mins.append(random.randint(1,90))
    bankroll_total_values = []
    total_bets = []
    if not baseline:
        multiply = 5
    else:
        multiply = 1
    for times in range(multiply):
        count_kelly = 0
        count_rue_salv = 0
        count_fixed_bet = 0
        count_fixed_return = 0
        dataset = split_set(divider=0, path=rootdir_train, case=case)
        if train_model:
            model, _ = train(dataset, 50, crit="CE", lstm_layer=2, hidden_size=64, l_rate=0.001, opt="adam")
            torch.save(model, "models/case_" + str(case) + "_nr_" + str(times))
        else:
            model = torch.load("models/case_"+str(case)+"_nr_"+str(times))
        model.eval()
        matches_probabilites = []
        f = open("odds/uf_lo_export_nextgoal.txt", "r")
        match_values = []
        match_ids = []
        old_id = "14701021"
        for i in f.readlines():
            data = i.split()
            if data[0] != "Stop":
                new_id = data[1]
                if new_id not in match_ids:
                    match_ids.append(new_id)
                if new_id == "match_id":
                    continue
                match_values.append(data)
            if new_id != old_id or data[0] == "Stop":
                matches_probabilites.append(match_values)
                match_values = []
            old_id = new_id
        del match_ids[0]
        x = []
        y = []
        id = []
        time_sets = []
        if case == 4 or case == 5 or case == 6:
            filter_matches = dataset.case_4_5_6_test
        else:
            filter_matches = dataset.case_1_2_3_test
        for files in os.walk(rootdir_test):
            if shuffle:
                random.shuffle(files[2])
            for file in files[2]:
                label = []
                if str(file.split(".")[0]) in match_ids and file.split(".")[0] in filter_matches: #checks if xxxxx.csv is in games
                    id.append(file.split(".")[0])
                    with open(rootdir_test.split("/")[5] + "/" + file, 'rU') as csvfile:
                        reader = csvv.reader(csvfile, delimiter=',')
                        action = list(reader)
                    hold = []
                    hold_time = []
                    for i in action:
                        if i[-2] == "home":
                            label.append([float(1),float(0),float(0)])
                        elif i[-2] == "away":
                            label.append([float(0),float(0),float(1)])
                        else:
                            label.append([float(0),float(1),float(0)])
                        del i[-2]
                        time = i[-1]
                        del i[-1]
                        set = [float(j) for j in i]

                        if case == 1 or case == 4:
                            set = set[0:]
                        if case == 2 or case == 5:
                            set = set[:5]
                        if case == 3 or case == 6:
                            set = [set[0]] + set[5:]

                        hold_time.append(time)
                        hold.append(set)
                    time_sets.append(hold_time)
                    x.append(hold)
                    y.append(label)
        bankroll_kelly = 100
        bankroll_rue_salv = 100
        bankroll_fixed_return = 100
        bankroll_fixed_bet = 100
        bets_kelly = 0
        bets_rue_salv = 0
        bets_fixed_return = 0
        bets_fixed_bet = 0
        bankroll_values = [[100,100,100,100]]
        unit = 0.01*bankroll_kelly
        wins = 0
        for i,data in enumerate(x):
            print("Match ID: "+id[i])
            output, hidden = model(torch.tensor(data))
            does_bet = False

            bet_team = "No Bet"
            odds = None
            if bet_min == "random":
                correct_time = closest_time_check(data,betting_mins[i])
            else:
                correct_time = closest_time_check(data,bet_min)
            for j, (x, p) in enumerate(zip(output,data)):

                answer = y[i][j]
                value = x.data
                time_odds = None
                if j != correct_time:
                    continue
                if does_bet:
                    continue
                for match in matches_probabilites:
                    time_diff = 0
                    for inter,l in enumerate(match):
                        if id[i] == l[1]:
                            FMT = '%H:%M:%S'
                            tdelta = datetime.strptime(l[3], FMT) - datetime.strptime(time_sets[i][j][11:19], FMT)
                            seconds = tdelta.total_seconds()
                            if not time_diff and seconds < 0:
                                time_diff = abs(seconds)
                                time_odds = l
                            elif abs(seconds) < time_diff and seconds < 0:
                                time_diff = abs(seconds)
                                time_odds = l
                if time_odds:
                    odds_home = 0.97/float(time_odds[6])
                    odds_none = 0.97/float(time_odds[8])
                    odds_away = 0.97/float(time_odds[10])
                    systems = ["fixed_bet","fixed_return","kelly","rue_salv"]
                    for sys in systems:
                        system = sys
                        bet_amount = 0
                        if system == "kelly":
                            percent_home = ((value[0].item() * odds_home) - 1)*0.25/(odds_home - 1)
                            percent_none = ((value[1].item() * odds_none) - 1)*0.25/(odds_none - 1)
                            percent_away = ((value[2].item() * odds_away) - 1)*0.25/(odds_away - 1)
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0
                            if bankroll_kelly != 0:
                                if unit_set.index(max(unit_set)) == 0\
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home > 1:
                                    if percent_home > 0:
                                        bet_home = bankroll_kelly * percent_home
                                        bet_amount = bet_home
                                        bet_team = "home"
                                        does_bet = True
                                        odds = odds_home
                                        count_kelly += 1
                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    if percent_none > 0:
                                        bet_none = bankroll_kelly * percent_none
                                        bet_amount = bet_none
                                        bet_team = "none"
                                        does_bet = True
                                        odds = odds_none
                                        count_kelly += 1
                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0 \
                                        and odds_away > 1:
                                    if percent_away > 0:
                                        bet_away = bankroll_kelly * percent_away
                                        bet_amount = bet_away
                                        bet_team = "away"
                                        does_bet = True
                                        odds = odds_away
                                        count_kelly += 1
                                if bet_team == "home" and answer.index(1) == 0:
                                    wins += 1
                                if bet_team == "none" and answer.index(1) == 1:
                                    wins += 1
                                if bet_team == "away" and answer.index(1) == 2:
                                    wins += 1

                            if answer.index(1) == 0:
                                if percent_home > 0 and bankroll_kelly: #bet as long as the percentage is positive
                                    bankroll_kelly -= bet_home
                                    bankroll_kelly += bet_home*odds_home
                                if percent_none > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_none
                                if percent_away > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_away
                            elif answer.index(1) == 1:
                                if percent_home > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_home
                                if percent_none > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_none
                                    bankroll_kelly += bet_none*odds_none
                                if percent_away > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_away
                            elif answer.index(1) == 2:
                                if percent_home > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_home
                                if percent_none > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_none
                                if percent_away > 0 and bankroll_kelly:
                                    bankroll_kelly -= bet_away
                                    bankroll_kelly += bet_away*odds_away
                            if int(bankroll_kelly) == 0 or int(bankroll_kelly) < 0:
                                bankroll_kelly= 0
                            bets_kelly += bet_amount
                            if bet_amount > 0:
                                print("Match ID: " + id[i])
                                print("kelly: "+str(bet_amount) + " on " + bet_team + "---->",bankroll_kelly," Odds:",odds)

                        elif system == "rue_salv":
                            percent_home = 1/(2*odds_home*(1-value[0].item()))
                            percent_none = 1/(2*odds_none*(1-value[1].item()))
                            percent_away = 1/(2*odds_away*(1-value[2].item()))
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0

                            if bankroll_rue_salv != 0:
                                if unit_set.index(max(unit_set)) == 0\
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home > 1:
                                    bet_home = unit * percent_home
                                    bet_amount = bet_home
                                    bet_team = "home"
                                    does_bet = True
                                    odds = odds_home
                                    count_rue_salv += 1

                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    bet_none = unit * percent_none
                                    bet_amount = bet_none
                                    bet_team = "none"
                                    does_bet = True
                                    odds = odds_none
                                    count_rue_salv += 1

                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0\
                                        and odds_away > 1:
                                    bet_away = unit * percent_away
                                    bet_amount = bet_away
                                    bet_team = "away"
                                    does_bet = True
                                    odds = odds_away
                                    count_rue_salv += 1

                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if answer.index(1) == 0:
                                    if bankroll_rue_salv:
                                        bankroll_rue_salv += bet_home*odds_home
                                        bankroll_rue_salv -= bet_home
                                        bankroll_rue_salv -= bet_none
                                        bankroll_rue_salv -= bet_away
                            elif answer.index(1) == 1:
                                    if bankroll_rue_salv:
                                        bankroll_rue_salv -= bet_home
                                        bankroll_rue_salv += bet_none*odds_none
                                        bankroll_rue_salv -= bet_none
                                        bankroll_rue_salv -= bet_away
                            elif answer.index(1) == 2:
                                    if bankroll_rue_salv:
                                        bankroll_rue_salv -= bet_home
                                        bankroll_rue_salv -= bet_none
                                        bankroll_rue_salv -= bet_away
                                        bankroll_rue_salv += bet_away*odds_away
                            if int(bankroll_rue_salv) == 0 or int(bankroll_rue_salv) < 0:
                                bankroll_rue_salv= 0
                            bets_rue_salv += bet_amount
                            print("rue_salv: "+str(bet_amount) + " on " + bet_team + "---->",bankroll_rue_salv)
                        elif system == "fixed_bet":
                            if baseline == "home":
                                unit_set = [0]
                            elif baseline == "egrt":
                                unit_set = [data[j][1], -9999, data[j][2]]
                            elif baseline == "xg":
                                unit_set = [data[j][3], -9999, data[j][4]]
                            elif baseline == "low_odds":
                                unit_set = [-odds_home, -odds_none, -odds_away]
                            else:
                                unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0

                            if bankroll_fixed_bet != 0:
                                if unit_set.index(max(unit_set)) == 0\
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home > 1:  # bet on highest kelly percent
                                    bet_home = unit
                                    bet_amount = bet_home
                                    bet_team = "home"
                                    does_bet = True
                                    odds = odds_home
                                    count_fixed_bet += 1

                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0\
                                        and odds_none > 1:
                                    bet_none = unit
                                    bet_amount = bet_none
                                    bet_team = "none"
                                    does_bet = True
                                    odds = odds_none
                                    count_fixed_bet += 1

                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0\
                                        and odds_away > 1:
                                    bet_away = unit
                                    bet_amount = bet_away
                                    bet_team = "away"
                                    does_bet = True
                                    odds = odds_away
                                    count_fixed_bet += 1

                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if answer.index(1) == 0:
                                    if bankroll_fixed_bet:
                                        bankroll_fixed_bet += bet_home*odds_home
                                        bankroll_fixed_bet -= bet_home
                                        bankroll_fixed_bet -= bet_none
                                        bankroll_fixed_bet -= bet_away
                            elif answer.index(1) == 1:
                                    if bankroll_fixed_bet:
                                        bankroll_fixed_bet -= bet_home
                                        bankroll_fixed_bet += bet_none * odds_none
                                        bankroll_fixed_bet -= bet_none
                                        bankroll_fixed_bet -= bet_away
                            elif answer.index(1) == 2:
                                    if bankroll_fixed_bet:
                                        bankroll_fixed_bet -= bet_home
                                        bankroll_fixed_bet -= bet_none
                                        bankroll_fixed_bet -= bet_away
                                        bankroll_fixed_bet += bet_away*odds_away
                            if int(bankroll_fixed_bet) == 0 or int(bankroll_fixed_bet) < 0:
                                bankroll_fixed_bet= 0
                            bets_fixed_bet += bet_amount
                            print("fixed_bet: "+str(bet_amount) + " on " + bet_team + "---->",bankroll_fixed_bet)
                        elif system == "fixed_return":
                            percent_home = 1 / odds_home
                            percent_none = 1 / odds_none
                            percent_away = 1 / odds_away
                            if baseline == "home":
                                unit_set = [0]
                            elif baseline == "egrt":
                                unit_set = [data[j][1], -9999, data[j][2]]
                            elif baseline == "xg":
                                unit_set = [data[j][3], -9999, data[j][4]]
                            elif baseline == "low_odds":
                                unit_set = [-odds_home, -odds_none, -odds_away]
                            else:
                                unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0

                            if bankroll_fixed_return != 0:
                                if unit_set.index(max(unit_set)) == 0 \
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home> 1:  # bet on highest kelly percent
                                    bet_home = percent_home
                                    bet_amount = bet_home
                                    bet_team = "home"
                                    does_bet = True
                                    odds = odds_home
                                    count_fixed_return += 1

                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    bet_none = percent_none
                                    bet_amount = bet_none
                                    bet_team = "none"
                                    does_bet = True
                                    odds = odds_none
                                    count_fixed_return += 1
                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0 \
                                        and odds_away > 1:
                                    bet_away = percent_away
                                    bet_amount = bet_away
                                    bet_team = "away"
                                    does_bet = True
                                    odds = odds_away
                                    count_fixed_return += 1
                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if answer.index(1) == 0:
                                    if bankroll_fixed_return:
                                        bankroll_fixed_return += bet_home*odds_home
                                        bankroll_fixed_return -= bet_home
                                        bankroll_fixed_return -= bet_none
                                        bankroll_fixed_return -= bet_away
                            elif answer.index(1) == 1:
                                    if bankroll_fixed_return:
                                        bankroll_fixed_return -= bet_home
                                        bankroll_fixed_return += bet_none*odds_none
                                        bankroll_fixed_return -= bet_none
                                        bankroll_fixed_return -= bet_away
                            elif answer.index(1) == 2:
                                    if bankroll_fixed_return:
                                        bankroll_fixed_return -= bet_home
                                        bankroll_fixed_return -= bet_none
                                        bankroll_fixed_return -= bet_away
                                        bankroll_fixed_return += bet_away*odds_away

                            if int(bankroll_fixed_return) == 0 or int(bankroll_fixed_return) < 0:
                                bankroll_fixed_return= 0
                            bets_fixed_return += bet_amount
                            print("fixed_return: "+str(bet_amount) + " on " + bet_team + "---->",bankroll_fixed_return)

                    does_bet = True
            bankroll_values.append([bankroll_fixed_bet,bankroll_fixed_return,bankroll_kelly,bankroll_rue_salv])
        print(count_fixed_bet,count_fixed_return,count_kelly,count_rue_salv,"------------------------------------------------------")
        bankroll_total_values.append(bankroll_values)
        total_bets.append([bets_fixed_bet, bets_fixed_return,bets_kelly,bets_rue_salv])

    label = []
    system_id = [2]
    for j in range(len(bankroll_values)):
        label.append(j)

    for s in system_id:

        name = None
        if s == 0:
            name = "Fixed bet"
        elif s == 1:
            name = "Fixed Return"
        elif s == 2:
            name = "Kelly"
        elif s == 3:
            name = "Variance-adjusted"

        print("\n\n\n"+name)
        avrg_bankroll = []
        ROIs = []
        for l,bankroll in enumerate(bankroll_total_values):
            if total_bets[l][s] != 0:
                print(total_bets[l][s],"run:",l)
                ROIs.append(((bankroll[-1][s] - 100) / total_bets[l][s]) * 100)

        best_roi = ROIs.index(max(ROIs))
        worst_roi = ROIs.index(min(ROIs))
        for p in label:
            avrg = 0
            for roll in bankroll_total_values:
                avrg = avrg + roll[p][s]
            avrg_bankroll.append(avrg/len(bankroll_total_values))
        average_roi_value = sum(ROIs)/len(ROIs)
        print("Best ROI: " +str(max(ROIs))+" on run nr: "+ str(best_roi))
        print("Worst ROI: " + str(min(ROIs)) + " on run nr: " + str(worst_roi))
        print("Average ROI: " + str(average_roi_value))
        if type(bet_min) == int:

            hold_value = [x[s] if x else None for x in bankroll_total_values[best_roi]]
            worst_value = [x[s] if x else None for x in bankroll_total_values[worst_roi]]
            plt.figure()
            plt.xlabel("Match")
            plt.ylabel("Bankroll")
            plt.plot(label, worst_value, 'r-', label='Min')
            plt.plot(label, hold_value, 'g-', label='Max')
            plt.plot(label, avrg_bankroll, 'y-', label='Avg')
            plt.axhline(y=100, color='k', linestyle='-')
            plt.legend(loc=0, ncol=2)
            plt.title("Case "+str(case)+" - "+name)
            plt.show()
def betting_sim_3(rootdir_test, shuffle = True, case = 1): # Continuous betting, Betting simulation 3
    bankroll_total_values = []
    total_bets = []
    for times in range(5):
        count_kelly = 0
        count_rue_salv = 0
        model = torch.load("models/case_"+str(case)+"_nr_"+str(times))
        model.eval()
        rootdir = rootdir_test
        matches_probabilites = []
        f = open("odds/uf_lo_export_nextgoal.txt", "r")
        match_values = []
        match_ids = []
        old_id = "14701021"
        for i in f.readlines():
            data = i.split()
            if data[0] != "Stop":
                new_id = data[1]
                if new_id not in match_ids:
                    match_ids.append(new_id)
                if new_id == "match_id":
                    continue
                match_values.append(data)
            if new_id != old_id or data[0] == "Stop":
                matches_probabilites.append(match_values)
                match_values = []
            old_id = new_id
        del match_ids[0]
        x = []
        y = []
        id = []
        time_sets = []
        dataset = split_set(divider=0, path=rootdir, case=case)
        if case == 4 or case == 5 or case == 6:
            filter_matches = dataset.case_4_5_6_test
        else:
            filter_matches = dataset.case_1_2_3_test
        for files in os.walk(rootdir):
            if shuffle:
                random.shuffle(files[2])
            for file in files[2]:
                label = []
                if str(file.split(".")[0]) in match_ids and file.split(".")[0] in filter_matches: #checks if xxxxx.csv is in games
                    id.append(file.split(".")[0])
                    with open(rootdir.split("/")[5]+"/"+file, 'rU') as csvfile:
                        reader = csvv.reader(csvfile, delimiter=',')
                        action = list(reader)
                    hold = []
                    hold_time = []
                    for i in action:
                        if i[-2] == "home":
                            label.append([float(1),float(0),float(0)])
                        elif i[-2] == "away":
                            label.append([float(0),float(0),float(1)])
                        else:
                            label.append([float(0),float(1),float(0)])
                        del i[-2]
                        time = i[-1]
                        del i[-1]
                        set = [float(j) for j in i]

                        if case == 1 or case == 4:
                            set = set[0:]
                        if case == 2 or case == 5:
                            set = set[:5]
                        if case == 3 or case == 6:
                            set = [set[0]] + set[5:]

                        hold_time.append(time)
                        hold.append(set)
                    time_sets.append(hold_time)
                    x.append(hold)
                    y.append(label)
        bankroll_kelly_1 = 100
        bankroll_kelly_2 = 100
        bankroll_rue_salv_1 = 100
        bankroll_rue_salv_2 = 100
        bets_kelly_1 = 0
        bets_kelly_2 = 0
        bets_rue_salv_1 = 0
        bets_rue_salv_2 = 0
        bankroll_values = [[100,100,100,100]]
        unit = 0.01*bankroll_kelly_1
        wins = 0
        for i,data in enumerate(x): #FOR EACH GAME
            print("\nMatch ID: "+id[i])
            output, hidden = model(torch.tensor(data))
            does_bet = False
            kelly_bets_1 = []
            kelly_bets_2 = []
            rue_salv_bets_1 = []
            rue_salv_bets_2 = []
            bet_team = "No Bet"
            odds = None
            intervals = list(range(5,95,5))
            for j, (x, p) in enumerate(zip(output,data)): #FOR EACH ACTION
                correct_time = closest_time_check(data, intervals[0])
                answer = y[i][j]
                value = x.data
                time_odds = None
                time = p[0]
                if kelly_bets_1:
                    if p[5] == 1.0:
                        for l, bet in enumerate(kelly_bets_1):
                            if bet[3]:
                                print("KELLY1 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_1 += bet[-2] * bet[-1]
                        kelly_bets_1 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(kelly_bets_1):
                            if bet[3]:
                                print("KELLY1 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_1 += bet[-2] * bet[-1]
                        kelly_bets_1 = []
                if kelly_bets_2:
                    if p[5] == 1.0:
                        for l, bet in enumerate(kelly_bets_2):
                            if bet[3]:
                                print("KELLY2 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_2 += bet[-2] * bet[-1]
                        kelly_bets_2 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(kelly_bets_2):
                            if bet[3]:
                                print("KELLY2 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_2 += bet[-2] * bet[-1]
                        kelly_bets_2 = []
                if rue_salv_bets_1:
                    if p[5] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_1):
                            if bet[3]:
                                print("VAR1 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_1 += bet[-2] * bet[-1]
                        rue_salv_bets_1 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_1):
                            if bet[3]:
                                print("VAR1 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_1 += bet[-2] * bet[-1]
                        rue_salv_bets_1 = []
                if rue_salv_bets_2:
                    if p[5] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_2):
                            if bet[3]:
                                print("VAR2 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_2 += bet[-2] * bet[-1]
                        rue_salv_bets_2 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_2):
                            if bet[3]:
                                print("VAR2 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_2 += bet[-2] * bet[-1]
                        rue_salv_bets_2 = []

                if j != correct_time and j+1 != len(data):
                    continue
                else:
                    del intervals[0]
                for match in matches_probabilites:
                    time_diff = 0
                    for inter,l in enumerate(match):
                        if id[i] == l[1]:
                            FMT = '%H:%M:%S'
                            tdelta = datetime.strptime(l[3], FMT) - datetime.strptime(time_sets[i][j][11:19], FMT)
                            seconds = tdelta.total_seconds()
                            if not time_diff and seconds < 0:
                                time_diff = abs(seconds)
                                time_odds = l
                            elif abs(seconds) < time_diff and seconds < 0:
                                time_diff = abs(seconds)
                                time_odds = l

                if time_odds:
                    odds_home = 0.97/float(time_odds[6])
                    odds_none = 0.97/float(time_odds[8])
                    odds_away = 0.97/float(time_odds[10])

                    systems = ["kelly_1","kelly_2","rue_salv_1","rue_salv_2"]
                    for sys in systems:
                        system = sys
                        bet_amount = 0
                        if system == "kelly_1":
                            percent_home = ((value[0].item() * odds_home) - 1)*0.25/(odds_home - 1)
                            percent_none = ((value[1].item() * odds_none) - 1)*0.25/(odds_none - 1)
                            percent_away = ((value[2].item() * odds_away) - 1)*0.25/(odds_away - 1)
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0
                            if bankroll_kelly_1 != 0:
                                if unit_set.index(max(unit_set)) == 0\
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home > 1:
                                    if percent_home > 0:
                                        bet_home = bankroll_kelly_1 * percent_home
                                        found = False
                                        if kelly_bets_1:
                                            total_betted = 0
                                            for b in kelly_bets_1:
                                                if b[2] == "home":
                                                    total_betted += b[-2]
                                                    found = True
                                            if found and bet_home > total_betted:
                                                bet_amount = bet_home - total_betted
                                                if bankroll_kelly_1 >= bet_amount and bankroll_kelly_1 > 0 and bet_amount > 0:
                                                    bankroll_kelly_1 -= bet_amount
                                                    bet_team = "home"
                                                    does_bet = True
                                                    odds = odds_home
                                                    count_kelly += 1
                                                    kelly_bets_1.append([time_odds[3],time,bet_team,0 == answer.index(1), bet_amount,odds])
                                        if not found:
                                            if bankroll_kelly_1 >= bet_home and bankroll_kelly_1 > 0 and bet_home > 0:
                                                bet_amount = bet_home
                                                bankroll_kelly_1 -= bet_amount
                                                bet_team = "home"
                                                does_bet = True
                                                odds = odds_home
                                                count_kelly += 1
                                                kelly_bets_1.append(
                                                    [time_odds[3], time,bet_team,0 == answer.index(1), bet_amount,odds])
                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    if percent_none > 0:
                                        bet_none = bankroll_kelly_1 * percent_none
                                        found = False
                                        if kelly_bets_1:
                                            total_betted = 0
                                            for b in kelly_bets_1:
                                                if b[2] == "none":
                                                    total_betted += b[-2]
                                                    found = True
                                            if found and bet_none > total_betted:
                                                bet_amount = bet_none - total_betted
                                                if bankroll_kelly_1 >= bet_amount and bankroll_kelly_1 > 0 and bet_amount > 0:
                                                    bankroll_kelly_1 -= bet_amount
                                                    bet_team = "none"
                                                    does_bet = True
                                                    odds = odds_none
                                                    count_kelly += 1
                                                    kelly_bets_1.append([time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                        if not found:
                                            if bankroll_kelly_1 >= bet_none and bankroll_kelly_1 > 0 and bet_none > 0:
                                                bet_amount = bet_none
                                                bankroll_kelly_1 -= bet_amount
                                                bet_team = "none"
                                                does_bet = True
                                                odds = odds_none
                                                count_kelly += 1
                                                kelly_bets_1.append(
                                                    [time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0 \
                                        and odds_away > 1:
                                    if percent_away > 0:
                                        bet_away = bankroll_kelly_1 * percent_away
                                        found = False
                                        if kelly_bets_1:
                                            total_betted = 0
                                            for b in kelly_bets_1:
                                                if b[2] == "away":
                                                    total_betted += b[-2]
                                                    found = True
                                            if found and bet_away > total_betted:
                                                bet_amount = bet_away - total_betted
                                                if bankroll_kelly_1 >= bet_amount and bankroll_kelly_1 > 0 and bet_amount > 0:
                                                    bankroll_kelly_1 -= bet_amount
                                                    bet_team = "away"
                                                    does_bet = True
                                                    odds = odds_away
                                                    count_kelly += 1
                                                    kelly_bets_1.append([time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                        if not found:
                                            if bankroll_kelly_1 >= bet_away and bankroll_kelly_1 > 0 and bet_away > 0:
                                                bet_amount = bet_away
                                                bankroll_kelly_1 -= bet_amount
                                                bet_team = "away"
                                                does_bet = True
                                                odds = odds_away
                                                count_kelly += 1
                                                kelly_bets_1.append(
                                                    [time_odds[3], time,bet_team,2 == answer.index(1), bet_amount,odds])
                                if bet_team == "home" and answer.index(1) == 0:
                                    wins += 1
                                if bet_team == "none" and answer.index(1) == 1:
                                    wins += 1
                                if bet_team == "away" and answer.index(1) == 2:
                                    wins += 1
                            if bet_amount >0:
                                bets_kelly_1 += bet_amount
                            print("kelly_1: " + str(bet_amount) + " on " + bet_team + "(", unit_set,
                                  "). With Odds: " + str(odds) + "---->", bankroll_kelly_1)
                            if j + 1 == len(data):
                                for o in kelly_bets_1:
                                    if o[3]:
                                        bankroll_kelly_1 += o[-2] * o[-1]
                        elif system == "kelly_2":
                                percent_home = ((value[0].item() * odds_home) - 1) * 0.25 / (odds_home - 1)
                                percent_none = ((value[1].item() * odds_none) - 1) * 0.25 / (odds_none - 1)
                                percent_away = ((value[2].item() * odds_away) - 1) * 0.25 / (odds_away - 1)
                                unit_set = [value[0].item(), value[1].item(), value[2].item()]
                                bet_home = 0
                                bet_none = 0
                                bet_away = 0
                                if bankroll_kelly_2 != 0:
                                    if unit_set.index(max(unit_set)) == 0 \
                                            and (odds_home * value[0].item() - 1) > 0 \
                                            and odds_home > 1:
                                        if percent_home > 0:
                                            bet_home = bankroll_kelly_2 * percent_home
                                            found = False
                                            other_bets = 0
                                            total_betted = 0
                                            for b in kelly_bets_2:
                                                if b[2] != "home":
                                                    other_bets += b[-2]
                                                if b[2] == "home":
                                                    total_betted += b[-2]
                                                    found = True
                                            if kelly_bets_2 and found:
                                                if kelly_bets_2[-1][2] != "home":
                                                    if bet_home < total_betted:
                                                        bet_amount = other_bets / odds_home
                                                    else:
                                                        bet_amount = bet_home - total_betted + other_bets / odds_home
                                                elif bet_home > total_betted:
                                                    bet_amount = bet_home - total_betted
                                                if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                    bankroll_kelly_2 -= bet_amount
                                                    bet_team = "home"
                                                    does_bet = True
                                                    odds = odds_home
                                                    count_kelly += 1
                                                    kelly_bets_2.append([time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])
                                            if not found:

                                                bet_amount = bet_home + other_bets / odds_home
                                                if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                    bankroll_kelly_2 -= bet_amount
                                                    bet_team = "home"
                                                    does_bet = True
                                                    odds = odds_home
                                                    count_kelly += 1
                                                    kelly_bets_2.append(
                                                        [time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])
                                    if unit_set.index(max(unit_set)) == 1 \
                                            and (odds_none * value[1].item() - 1) > 0 \
                                            and odds_none > 1:
                                        if percent_none > 0:
                                            bet_none = bankroll_kelly_2 * percent_none
                                            found = False
                                            other_bets = 0
                                            total_betted = 0
                                            for b in kelly_bets_2:
                                                if b[2] != "none":
                                                    other_bets += b[-2]
                                                if b[2] == "none":
                                                    total_betted += b[-2]
                                                    found = True
                                            if kelly_bets_2 and found:
                                                if kelly_bets_2[-1][2] != "none":
                                                    if bet_none < total_betted:
                                                        bet_amount = other_bets / odds_none
                                                    else:
                                                        bet_amount = bet_none - total_betted + other_bets / odds_none
                                                elif bet_amount > total_betted:
                                                    bet_amount = bet_none - total_betted
                                                if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                    bankroll_kelly_2 -= bet_amount
                                                    bet_team = "none"
                                                    does_bet = True
                                                    odds = odds_none
                                                    count_kelly += 1
                                                    kelly_bets_2.append([time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                            if not found:
                                                bet_amount = bet_none + other_bets / odds_none
                                                if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                    bankroll_kelly_2 -= bet_amount
                                                    bet_team = "none"
                                                    does_bet = True
                                                    odds = odds_none
                                                    count_kelly += 1
                                                    kelly_bets_2.append(
                                                        [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])
                                    if unit_set.index(max(unit_set)) == 2 \
                                            and (odds_away * value[2].item() - 1) > 0 \
                                            and odds_away > 1:
                                        if percent_away > 0:
                                            bet_away = bankroll_kelly_2 * percent_away
                                            found = False
                                            other_bets = 0
                                            total_betted = 0
                                            for b in kelly_bets_2:
                                                if b[2] != "away":
                                                    other_bets += b[-2]
                                                if b[2] == "away":
                                                    total_betted += b[-2]
                                                    found = True
                                            if kelly_bets_2 and found:
                                                if kelly_bets_2[-1][2] != "away":
                                                    if bet_away < total_betted:
                                                        bet_amount = other_bets / odds_away
                                                    else:
                                                        bet_amount = bet_away - total_betted + other_bets / odds_away
                                                elif bet_away > total_betted:
                                                    bet_amount = bet_away - total_betted
                                                if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                    bankroll_kelly_2 -= bet_amount
                                                    bet_team = "away"
                                                    does_bet = True
                                                    odds = odds_away
                                                    count_kelly += 1
                                                    kelly_bets_2.append([time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                            if not found:
                                                bet_amount = bet_away + other_bets / odds_away
                                                if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                    bankroll_kelly_2 -= bet_amount
                                                    bet_team = "away"
                                                    does_bet = True
                                                    odds = odds_away
                                                    count_kelly += 1
                                                    kelly_bets_2.append(
                                                        [time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                    if bet_team == "home" and answer.index(1) == 0:
                                        wins += 1
                                    if bet_team == "none" and answer.index(1) == 1:
                                        wins += 1
                                    if bet_team == "away" and answer.index(1) == 2:
                                        wins += 1
                                if bet_amount > 0:
                                    bets_kelly_2 += bet_amount
                                print("kelly_2: " + str(bet_amount) + " on " + bet_team + "(", unit_set,
                                      "). With Odds: " + str(odds) + "---->", bankroll_kelly_2)
                                if j + 1 == len(data):
                                    for o in kelly_bets_2:
                                        if o[3]:
                                            bankroll_kelly_2 += o[-2] * o[-1]
                        elif system == "rue_salv_1":
                            percent_home = 1/(2*odds_home*(1-value[0].item()))
                            percent_none = 1/(2*odds_none*(1-value[1].item()))
                            percent_away = 1/(2*odds_away*(1-value[2].item()))
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0
                            if bankroll_rue_salv_1 != 0:
                                if unit_set.index(max(unit_set)) == 0\
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home > 1:

                                    bet_home = unit * percent_home
                                    found = False
                                    if rue_salv_bets_1:
                                        total_betted = 0
                                        for b in rue_salv_bets_1:
                                            if b[2] == "home":
                                                total_betted += b[-2]
                                                found = True
                                        if found and bet_home > total_betted:
                                            bet_amount = bet_home - total_betted
                                            if bankroll_rue_salv_1 >= bet_amount and int(bankroll_rue_salv_1) > 0 and bet_amount > 0:
                                                bankroll_rue_salv_1 -= bet_amount
                                                bet_team = "home"
                                                does_bet = True
                                                odds = odds_home
                                                count_rue_salv += 1
                                                rue_salv_bets_1.append(
                                                    [time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        if bankroll_rue_salv_1 >= bet_home and int(bankroll_rue_salv_1) != 0 and bet_home > 0:
                                            bet_amount = bet_home
                                            bankroll_rue_salv_1 -= bet_amount
                                            bet_team = "home"
                                            does_bet = True
                                            odds = odds_home
                                            count_rue_salv += 1
                                            rue_salv_bets_1.append(
                                                [time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])


                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    bet_none = unit * percent_none
                                    found = False
                                    if rue_salv_bets_1:
                                        total_betted = 0
                                        for b in rue_salv_bets_1:
                                            if b[2] == "none":
                                                total_betted += b[-2]
                                                found = True
                                        if found and bet_home > total_betted:
                                            bet_amount = bet_none - total_betted
                                            if bankroll_rue_salv_1 >= bet_amount and int(bankroll_rue_salv_1) > 0 and bet_amount > 0:
                                                bankroll_rue_salv_1 -= bet_amount
                                                bet_team = "none"
                                                does_bet = True
                                                odds = odds_none
                                                count_rue_salv += 1
                                                rue_salv_bets_1.append(
                                                    [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        if bankroll_rue_salv_1 >= bet_none and int(bankroll_rue_salv_1) > 0 and bet_none > 0:
                                            bet_amount = bet_none
                                            bankroll_rue_salv_1 -= bet_amount
                                            bet_team = "none"
                                            does_bet = True
                                            odds = odds_none
                                            count_rue_salv += 1
                                            rue_salv_bets_1.append(
                                                [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0\
                                        and odds_away > 1:
                                    bet_away = unit * percent_away
                                    found = False
                                    if rue_salv_bets_1:
                                        total_betted = 0
                                        for b in rue_salv_bets_1:
                                            if b[2] == "away":
                                                total_betted += b[-2]
                                                found = True
                                        if found and bet_home > total_betted:
                                            bet_amount = bet_away - total_betted
                                            if bankroll_rue_salv_1 >= bet_amount and int(bankroll_rue_salv_1) > 0 and bet_amount > 0:
                                                bankroll_rue_salv_1 -= bet_amount
                                                bet_team = "away"
                                                does_bet = True
                                                odds = odds_away
                                                count_rue_salv += 1
                                                rue_salv_bets_1.append(
                                                    [time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        if bankroll_rue_salv_1 >= bet_away and int(bankroll_rue_salv_1) > 0 and bet_away > 0:
                                            bet_amount = bet_away
                                            bankroll_rue_salv_1 -= bet_amount
                                            bet_team = "away"
                                            does_bet = True
                                            odds = odds_away
                                            count_rue_salv += 1
                                            rue_salv_bets_1.append(
                                                [time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if bet_amount > 0:
                                bets_rue_salv_1 += bet_amount
                            print("rue_salv_1: " + str(bet_amount) + " on " + bet_team + "(",unit_set,"). With Odds: "+str(odds)+"---->", bankroll_rue_salv_1)
                            if j+1 == len(data):
                                for o in rue_salv_bets_1:
                                    print(o)
                                    if o[3]:
                                        bankroll_rue_salv_1 += o[-2] * o[-1]
                        elif system == "rue_salv_2":
                            percent_home = 1 / (2 * odds_home * (1 - value[0].item()))
                            percent_none = 1 / (2 * odds_none * (1 - value[1].item()))
                            percent_away = 1 / (2 * odds_away * (1 - value[2].item()))
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0
                            if bankroll_rue_salv_2 != 0:
                                if unit_set.index(max(unit_set)) == 0 \
                                        and (odds_home * value[0].item() - 1) > 0 \
                                        and odds_home > 1:

                                    bet_home = unit * percent_home
                                    found = False
                                    other_bets = 0
                                    total_betted = 0
                                    for b in rue_salv_bets_2:
                                        if b[2] != "home":
                                            other_bets += b[-2]
                                        if b[2] == "home":
                                            total_betted += b[-2]
                                            found = True
                                    if rue_salv_bets_2 and found:
                                        if rue_salv_bets_2[-1][2] != "home":
                                            if bet_home < total_betted:
                                                bet_amount = other_bets / odds_home
                                            else:
                                                bet_amount = bet_home - total_betted + other_bets / odds_home
                                        elif bet_home > total_betted:
                                            bet_amount = bet_home - total_betted
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "home"
                                            does_bet = True
                                            odds = odds_home
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time, bet_team,0 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        bet_amount = bet_home + other_bets / odds_home
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "home"
                                            does_bet = True
                                            odds = odds_home
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time, bet_team,0 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none * value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    bet_none = unit * percent_none
                                    found = False
                                    other_bets = 0
                                    total_betted = 0
                                    for b in rue_salv_bets_2:
                                        if b[2] != "none":
                                            other_bets += b[-2]
                                        if b[2] == "none":
                                            total_betted += b[-2]
                                            found = True
                                    if rue_salv_bets_2 and found:
                                        if rue_salv_bets_2[-1][2] != "none":
                                            if bet_none < total_betted:
                                                bet_amount = other_bets / odds_none
                                            else:
                                                bet_amount = bet_none - total_betted + other_bets / odds_none
                                        elif bet_none > total_betted:
                                            bet_amount = bet_none - total_betted
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "none"
                                            does_bet = True
                                            odds = odds_none
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        bet_amount = bet_none + other_bets / odds_none
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "none"
                                            does_bet = True
                                            odds = odds_none
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away * value[2].item() - 1) > 0 \
                                        and odds_away > 1:
                                    bet_away = unit * percent_away
                                    found = False
                                    other_bets = 0
                                    total_betted = 0
                                    for b in rue_salv_bets_2:
                                        if b[2] != "away":
                                            other_bets += b[-2]
                                        if b[2] == "away":
                                            total_betted += b[-2]
                                            found = True
                                    if rue_salv_bets_2 and found and (bet_away - total_betted) > 0:
                                        if rue_salv_bets_2[-1][2] != "away":
                                            if bet_away < total_betted:
                                                bet_amount = other_bets / odds_away
                                            else:
                                                bet_amount = bet_away - total_betted + other_bets / odds_away
                                        elif bet_away > total_betted:
                                            bet_amount = bet_away - total_betted
                                            if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                                bankroll_rue_salv_2 -= bet_amount
                                                bet_team = "away"
                                                does_bet = True
                                                odds = odds_away
                                                count_rue_salv += 1
                                                rue_salv_bets_2.append(
                                                    [time_odds[3], time, bet_team,2 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        bet_amount = bet_away - other_bets / odds_away
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "away"
                                            does_bet = True
                                            odds = odds_away
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time,bet_team,2 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if bet_amount >0:
                                bets_rue_salv_2 += bet_amount
                            print("rue_salv_2: " + str(bet_amount) + " on " + bet_team + "(",unit_set,"). With Odds: "+str(odds)+"---->", bankroll_rue_salv_2)
                            if j+1 == len(data):
                                for o in rue_salv_bets_2:
                                    if o[3]:
                                        bankroll_rue_salv_2 += o[-2] * o[-1]
                    does_bet = True
                print("\n")
            bankroll_values.append([bankroll_kelly_1,bankroll_kelly_2,bankroll_rue_salv_1,bankroll_rue_salv_2])

        bankroll_total_values.append(bankroll_values)
        total_bets.append([bets_kelly_1, bets_kelly_2, bets_rue_salv_1, bets_rue_salv_2])


    label = []
    system_id = [0,1,2,3]
    print(total_bets)
    for j in range(len(bankroll_values)):
        label.append(j)

    for s in system_id:
        avrg_bankroll = []
        ROIs = []
        for l,bankroll in enumerate(bankroll_total_values):
            ROIs.append(((bankroll[-1][s] - 100) / total_bets[l][s]) * 100)

        best_roi = ROIs.index(max(ROIs))
        worst_roi = ROIs.index(min(ROIs))
        for p in label:
            avrg = 0
            for roll in bankroll_total_values:
                avrg = avrg + roll[p][s]
            avrg_bankroll.append(avrg/len(bankroll_total_values))



        average_roi_value = sum(ROIs)/len(ROIs)
        name = None
        if s == 0:
            name = "Kelly 1"
        elif s == 1:
            name = "Kelly 2"
        elif s == 2:
            name = "variance-adjusted 1"
        elif s == 3:
            name = "variance-adjusted 2"
        print("\n "+name)
        print("Best ROI: " +str(max(ROIs))+" on run nr: "+ str(best_roi))
        print("Worst ROI: " +str(min(ROIs))+" on run nr: "+ str(worst_roi))
        print("Average ROI: " + str(average_roi_value))

        plt.figure()
        plt.xlabel("Match")
        plt.ylabel("Bankroll")



        hold_value = [x[s] if x else None for x in bankroll_total_values[best_roi]]
        worst_hold_value = [x[s] if x else None for x in bankroll_total_values[worst_roi]]

        plt.plot(label, worst_hold_value, 'r-', label='Min')
        plt.plot(label, hold_value, 'g-', label='Max')
        plt.plot(label, avrg_bankroll, 'y-', label='Avg')
        plt.axhline(y=100, color='k', linestyle='-')
        plt.legend(loc=0, ncol=2)
        plt.title("Case " + str(case) + " - Continuous " + name)
        plt.show()
def betting_sim_3_regular(rootdir_test, shuffle = True, threshold ="probability", case = 1): #Continuous betting with regular strategies seen in 4.3.2 Case 1
    bankroll_total_values = []
    total_bets = []
    for times in range(5):
        count_kelly = 0
        count_rue_salv = 0
        model = torch.load("models/case_"+str(case)+"_nr_"+str(times))
        model.eval()
        rootdir = rootdir_test
        matches_probabilites = []
        f = open("odds/uf_lo_export_nextgoal.txt", "r")
        match_values = []
        match_ids = []
        old_id = "14701021"
        for i in f.readlines():
            data = i.split()
            if data[0] != "Stop":
                new_id = data[1]
                if new_id not in match_ids:
                    match_ids.append(new_id)
                if new_id == "match_id":
                    continue
                match_values.append(data)
            if new_id != old_id or data[0] == "Stop":
                matches_probabilites.append(match_values)
                match_values = []
            old_id = new_id
        del match_ids[0]
        x = []
        y = []
        id = []
        time_sets = []
        dataset = split_set(divider=0, path=rootdir, case=case)
        if case == 4 or case == 5 or case == 6:
            filter_matches = dataset.case_4_5_6_test
        else:
            filter_matches = dataset.case_1_2_3_test
        for files in os.walk(rootdir):
            if shuffle:
                random.shuffle(files[2])
            for file in files[2]:
                label = []
                if str(file.split(".")[0]) in match_ids and file.split(".")[0] in filter_matches: #checks if xxxxx.csv is in games
                    id.append(file.split(".")[0])
                    with open(rootdir.split("/")[5]+"/"+file, 'rU') as csvfile:
                        reader = csvv.reader(csvfile, delimiter=',')
                        action = list(reader)
                    hold = []
                    hold_time = []
                    for i in action:
                        if i[-2] == "home":
                            label.append([float(1),float(0),float(0)])
                        elif i[-2] == "away":
                            label.append([float(0),float(0),float(1)])
                        else:
                            label.append([float(0),float(1),float(0)])
                        del i[-2]
                        time = i[-1]
                        del i[-1]
                        set = [float(j) for j in i]

                        if case == 1 or case == 4:
                            set = set[0:]
                        if case == 2 or case == 5:
                            set = set[:5]
                        if case == 3 or case == 6:
                            set = [set[0]] + set[5:]

                        hold_time.append(time)
                        hold.append(set)
                    time_sets.append(hold_time)
                    x.append(hold)
                    y.append(label)
        bankroll_kelly_1 = 100
        bankroll_kelly_2 = 100
        bankroll_rue_salv_1 = 100
        bankroll_rue_salv_2 = 100
        bets_kelly_1 = 0
        bets_kelly_2 = 0
        bets_rue_salv_1 = 0
        bets_rue_salv_2 = 0
        bankroll_values = [[100,100,100,100]]
        unit = 0.01*bankroll_kelly_1
        wins = 0
        for i,data in enumerate(x): #FOR EACH GAME
            print("\nMatch ID: "+id[i]," NUMBER ",i)
            output, hidden = model(torch.tensor(data))
            does_bet = False
            kelly_bets_1 = []
            kelly_bets_2 = []
            rue_salv_bets_1 = []
            rue_salv_bets_2 = []
            bet_team = "No Bet"
            odds = None
            intervals = list(range(5,95,5))
            for j, (x, p) in enumerate(zip(output,data)): #FOR EACH ACTION
                correct_time = closest_time_check(data, intervals[0])
                answer = y[i][j]
                value = x.data
                time_odds = None
                time = p[0]
                if kelly_bets_1:
                    if p[5] == 1.0:
                        for l, bet in enumerate(kelly_bets_1):
                            if bet[3]:
                                print("KELLY1 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_1 += bet[-2] * bet[-1]
                        kelly_bets_1 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(kelly_bets_1):
                            if bet[3]:
                                print("KELLY1 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_1 += bet[-2] * bet[-1]
                        kelly_bets_1 = []
                if kelly_bets_2:
                    if p[5] == 1.0:
                        for l, bet in enumerate(kelly_bets_2):
                            if bet[3]:
                                print("KELLY2 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_2 += bet[-2] * bet[-1]
                        kelly_bets_2 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(kelly_bets_2):
                            if bet[3]:
                                print("KELLY2 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_kelly_2 += bet[-2] * bet[-1]
                        kelly_bets_2 = []
                if rue_salv_bets_1:
                    if p[5] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_1):
                            if bet[3]:
                                print("VAR1 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_1 += bet[-2] * bet[-1]
                        rue_salv_bets_1 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_1):
                            if bet[3]:
                                print("VAR1 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_1 += bet[-2] * bet[-1]
                        rue_salv_bets_1 = []
                if rue_salv_bets_2:
                    if p[5] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_2):
                            if bet[3]:
                                print("VAR2 HOME SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_2 += bet[-2] * bet[-1]
                        rue_salv_bets_2 = []
                    if p[6] == 1.0:
                        for l, bet in enumerate(rue_salv_bets_2):
                            if bet[3]:
                                print("VAR2 AWAY SCORED -  WINNING", bet[-2] * bet[-1])
                                bankroll_rue_salv_2 += bet[-2] * bet[-1]
                        rue_salv_bets_2 = []


                if j != correct_time and j+1 != len(data):
                    continue
                else:
                    del intervals[0]
                for match in matches_probabilites:
                    time_diff = 0
                    for inter,l in enumerate(match):
                        if id[i] == l[1]:
                            FMT = '%H:%M:%S'
                            tdelta = datetime.strptime(l[3], FMT) - datetime.strptime(time_sets[i][j][11:19], FMT)
                            seconds = tdelta.total_seconds()
                            if not time_diff and seconds < 0:
                                time_diff = abs(seconds)
                                time_odds = l
                            elif abs(seconds) < time_diff and seconds < 0:
                                time_diff = abs(seconds)
                                time_odds = l

                if time_odds:
                    odds_home = 0.97/float(time_odds[6])
                    odds_none = 0.97/float(time_odds[8])
                    odds_away = 0.97/float(time_odds[10])

                    systems = ["kelly_1","kelly_2","rue_salv_1","rue_salv_2"]
                    for sys in systems:
                        system = sys
                        bet_amount = 0
                        if system == "kelly_1":
                            percent_home = ((value[0].item() * odds_home) - 1)*0.25/(odds_home - 1)
                            percent_none = ((value[1].item() * odds_none) - 1)*0.25/(odds_none - 1)
                            percent_away = ((value[2].item() * odds_away) - 1)*0.25/(odds_away - 1)
                            if threshold == "kelly":
                                unit_set = [percent_home, percent_none, percent_away]
                            if threshold == "probability":
                                unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            if bankroll_kelly_1 != 0:
                                if threshold == "kelly":
                                    if unit_set.index(max(unit_set)) == 0 \
                                            and (odds_home*value[0].item() - 1) > 0 \
                                            and odds_home>1:  # bet on highest kelly percent
                                        bet_home = bankroll_kelly_1 * percent_home
                                        bet_amount = bet_home
                                        bet_team = "home"
                                        does_bet = True
                                        odds = odds_home
                                        count_kelly += 1

                                    if unit_set.index(max(unit_set)) == 1 \
                                            and (odds_none*value[1].item() - 1) > 0 \
                                            and odds_none:
                                        bet_none = bankroll_kelly_1 * percent_none
                                        bet_amount = bet_none
                                        bet_team = "none"
                                        does_bet = True
                                        odds = odds_none
                                        count_kelly += 1

                                    if unit_set.index(max(unit_set)) == 2 \
                                            and (odds_away*value[2].item() - 1) > 0 \
                                            and odds_away>1:
                                        bet_away = bankroll_kelly_1 * percent_away
                                        bet_amount = bet_away
                                        bet_team = "away"
                                        does_bet = True
                                        odds = odds_away
                                        count_kelly += 1

                                    if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                        wins += 1
                                elif threshold == "probability": # bet on highest probability of the bets with positive kelly. if the highest prob isnt positive then dont do
                                    if unit_set.index(max(unit_set)) == 0\
                                            and (odds_home*value[0].item() - 1) > 0 \
                                            and odds_home > 1:
                                        if percent_home > 0:
                                            bet_home = bankroll_kelly_1 * percent_home
                                            bet_amount = bet_home
                                            if bankroll_kelly_1 >= bet_amount and bankroll_kelly_1 > 0 and bet_amount > 0:
                                                bankroll_kelly_1 -= bet_amount
                                                bet_team = "home"
                                                does_bet = True
                                                odds = odds_home
                                                count_kelly += 1
                                                kelly_bets_1.append([time_odds[3],time,bet_team,0 == answer.index(1), bet_amount,odds])
                                    if unit_set.index(max(unit_set)) == 1 \
                                            and (odds_none*value[1].item() - 1) > 0 \
                                            and odds_none > 1:
                                        if percent_none > 0:
                                            bet_none = bankroll_kelly_1 * percent_none
                                            bet_amount = bet_none
                                            if bankroll_kelly_1 >= bet_amount and bankroll_kelly_1 > 0 and bet_amount > 0:
                                                bankroll_kelly_1 -= bet_amount
                                                bet_team = "none"
                                                does_bet = True
                                                odds = odds_none
                                                count_kelly += 1
                                                kelly_bets_1.append([time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                    if unit_set.index(max(unit_set)) == 2 \
                                            and (odds_away*value[2].item() - 1) > 0 \
                                            and odds_away > 1:
                                        if percent_away > 0:
                                            bet_away = bankroll_kelly_1 * percent_away
                                            bet_amount = bet_away
                                            if bankroll_kelly_1 >= bet_amount and bankroll_kelly_1 > 0 and bet_amount > 0:
                                                bankroll_kelly_1 -= bet_amount
                                                bet_team = "away"
                                                does_bet = True
                                                odds = odds_away
                                                count_kelly += 1
                                                kelly_bets_1.append([time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                    if bet_team == "home" and answer.index(1) == 0:
                                        wins += 1
                                    if bet_team == "none" and answer.index(1) == 1:
                                        wins += 1
                                    if bet_team == "away" and answer.index(1) == 2:
                                        wins += 1
                            if bet_amount >0:
                                bets_kelly_1 += bet_amount
                            print("kelly_1: " + str(bet_amount) + " on " + bet_team + "(", unit_set,
                                  "). With Odds: " + str(odds) + "---->", bankroll_kelly_1)
                            if j + 1 == len(data):
                                for o in kelly_bets_1:
                                    if o[3]:
                                        bankroll_kelly_1 += o[-2] * o[-1]
                        elif system == "kelly_2":
                                percent_home = ((value[0].item() * odds_home) - 1) * 0.25 / (odds_home - 1)
                                percent_none = ((value[1].item() * odds_none) - 1) * 0.25 / (odds_none - 1)
                                percent_away = ((value[2].item() * odds_away) - 1) * 0.25 / (odds_away - 1)
                                if threshold == "kelly":
                                    unit_set = [percent_home, percent_none, percent_away]
                                if threshold == "probability":
                                    unit_set = [value[0].item(), value[1].item(), value[2].item()]
                                bet_home = 0
                                bet_none = 0
                                bet_away = 0
                                if bankroll_kelly_2 != 0:
                                    if threshold == "kelly":
                                        if unit_set.index(max(unit_set)) == 0 \
                                                and (odds_home * value[0].item() - 1) > 0 \
                                                and odds_home > 1:  # bet on highest kelly percent
                                            bet_home = bankroll_kelly_2 * percent_home
                                            bet_amount = bet_home
                                            bet_team = "home"
                                            does_bet = True
                                            odds = odds_home
                                            count_kelly += 1

                                        if unit_set.index(max(unit_set)) == 1 \
                                                and (odds_none * value[1].item() - 1) > 0 \
                                                and odds_none:
                                            bet_none = bankroll_kelly_2 * percent_none
                                            bet_amount = bet_none
                                            bet_team = "none"
                                            does_bet = True
                                            odds = odds_none
                                            count_kelly += 1

                                        if unit_set.index(max(unit_set)) == 2 \
                                                and (odds_away * value[2].item() - 1) > 0 \
                                                and odds_away > 1:
                                            bet_away = bankroll_kelly_2 * percent_away
                                            bet_amount = bet_away
                                            bet_team = "away"
                                            does_bet = True
                                            odds = odds_away
                                            count_kelly += 1

                                        if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                            wins += 1
                                    elif threshold == "probability":  # bet on highest probability of the bets with positive kelly. if the highest prob isnt positive then dont do
                                        if unit_set.index(max(unit_set)) == 0 \
                                                and (odds_home * value[0].item() - 1) > 0 \
                                                and odds_home > 1:
                                            if percent_home > 0:
                                                bet_home = bankroll_kelly_2 * percent_home
                                                found = False
                                                other_bets = 0
                                                total_betted = 0
                                                for b in kelly_bets_2:
                                                    if b[2] != "home":
                                                        other_bets += b[-2]
                                                    if b[2] == "home":
                                                        total_betted += b[-2]
                                                        found = True
                                                if kelly_bets_2 and found:
                                                    if kelly_bets_2[-1][2] != "home":
                                                        if bet_home < total_betted:
                                                            bet_amount = other_bets / odds_home
                                                        else:
                                                            bet_amount = bet_home - total_betted + other_bets / odds_home
                                                    elif bet_home > total_betted:
                                                        bet_amount = bet_home - total_betted
                                                    if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                        bankroll_kelly_2 -= bet_amount
                                                        bet_team = "home"
                                                        does_bet = True
                                                        odds = odds_home
                                                        count_kelly += 1
                                                        kelly_bets_2.append([time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])
                                                if not found:

                                                    bet_amount = bet_home + other_bets / odds_home
                                                    if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                        bankroll_kelly_2 -= bet_amount
                                                        bet_team = "home"
                                                        does_bet = True
                                                        odds = odds_home
                                                        count_kelly += 1
                                                        kelly_bets_2.append(
                                                            [time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])
                                        if unit_set.index(max(unit_set)) == 1 \
                                                and (odds_none * value[1].item() - 1) > 0 \
                                                and odds_none > 1:
                                            if percent_none > 0:
                                                bet_none = bankroll_kelly_2 * percent_none
                                                found = False
                                                other_bets = 0
                                                total_betted = 0
                                                for b in kelly_bets_2:
                                                    if b[2] != "none":
                                                        other_bets += b[-2]
                                                    if b[2] == "none":
                                                        total_betted += b[-2]
                                                        found = True
                                                if kelly_bets_2 and found:
                                                    if kelly_bets_2[-1][2] != "none":
                                                        if bet_none < total_betted:
                                                            bet_amount = other_bets / odds_none
                                                        else:
                                                            bet_amount = bet_none - total_betted + other_bets / odds_none
                                                    elif bet_amount > total_betted:
                                                        bet_amount = bet_none - total_betted
                                                    if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                        bankroll_kelly_2 -= bet_amount
                                                        bet_team = "none"
                                                        does_bet = True
                                                        odds = odds_none
                                                        count_kelly += 1
                                                        kelly_bets_2.append([time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                                if not found:
                                                    bet_amount = bet_none + other_bets / odds_none
                                                    if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                        bankroll_kelly_2 -= bet_amount
                                                        bet_team = "none"
                                                        does_bet = True
                                                        odds = odds_none
                                                        count_kelly += 1
                                                        kelly_bets_2.append(
                                                            [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])
                                        if unit_set.index(max(unit_set)) == 2 \
                                                and (odds_away * value[2].item() - 1) > 0 \
                                                and odds_away > 1:
                                            if percent_away > 0:
                                                bet_away = bankroll_kelly_2 * percent_away
                                                found = False
                                                other_bets = 0
                                                total_betted = 0
                                                for b in kelly_bets_2:
                                                    if b[2] != "away":
                                                        other_bets += b[-2]
                                                    if b[2] == "away":
                                                        total_betted += b[-2]
                                                        found = True
                                                if kelly_bets_2 and found:
                                                    if kelly_bets_2[-1][2] != "away":
                                                        if bet_away < total_betted:
                                                            bet_amount = other_bets / odds_away
                                                        else:
                                                            bet_amount = bet_away - total_betted + other_bets / odds_away
                                                    elif bet_away > total_betted:
                                                        bet_amount = bet_away - total_betted
                                                    if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                        bankroll_kelly_2 -= bet_amount
                                                        bet_team = "away"
                                                        does_bet = True
                                                        odds = odds_away
                                                        count_kelly += 1
                                                        kelly_bets_2.append([time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                                if not found:
                                                    bet_amount = bet_away + other_bets / odds_away
                                                    if bankroll_kelly_2 >= bet_amount and bankroll_kelly_2 > 0 and bet_amount > 0:
                                                        bankroll_kelly_2 -= bet_amount
                                                        bet_team = "away"
                                                        does_bet = True
                                                        odds = odds_away
                                                        count_kelly += 1
                                                        kelly_bets_2.append(
                                                            [time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                        if bet_team == "home" and answer.index(1) == 0:
                                            wins += 1
                                        if bet_team == "none" and answer.index(1) == 1:
                                            wins += 1
                                        if bet_team == "away" and answer.index(1) == 2:
                                            wins += 1
                                if bet_amount > 0:
                                    bets_kelly_2 += bet_amount
                                print("kelly_2: " + str(bet_amount) + " on " + bet_team + "(", unit_set,
                                      "). With Odds: " + str(odds) + "---->", bankroll_kelly_2)
                                if j + 1 == len(data):
                                    for o in kelly_bets_2:
                                        if o[3]:
                                            bankroll_kelly_2 += o[-2] * o[-1]
                        elif system == "rue_salv_1":
                            percent_home = 1/(2*odds_home*(1-value[0].item()))
                            percent_none = 1/(2*odds_none*(1-value[1].item()))
                            percent_away = 1/(2*odds_away*(1-value[2].item()))
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0
                            if bankroll_rue_salv_1 != 0:
                                if unit_set.index(max(unit_set)) == 0\
                                        and (odds_home*value[0].item() - 1) > 0 \
                                        and odds_home > 1:

                                    bet_home = unit * percent_home
                                    bet_amount = bet_home
                                    if bankroll_rue_salv_1 >= bet_amount and int(bankroll_rue_salv_1) > 0 and bet_amount > 0:
                                        bankroll_rue_salv_1 -= bet_amount
                                        bet_team = "home"
                                        does_bet = True
                                        odds = odds_home
                                        count_rue_salv += 1
                                        rue_salv_bets_1.append(
                                            [time_odds[3], time,bet_team, 0 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none*value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    bet_none = unit * percent_none
                                    bet_amount = bet_none
                                    if bankroll_rue_salv_1 >= bet_amount and int(bankroll_rue_salv_1) > 0 and bet_amount > 0:
                                        bankroll_rue_salv_1 -= bet_amount
                                        bet_team = "none"
                                        does_bet = True
                                        odds = odds_none
                                        count_rue_salv += 1
                                        rue_salv_bets_1.append(
                                            [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away*value[2].item() - 1) > 0\
                                        and odds_away > 1:
                                    bet_away = unit * percent_away
                                    bet_amount = bet_away
                                    if bankroll_rue_salv_1 >= bet_amount and int(bankroll_rue_salv_1) > 0 and bet_amount > 0:
                                        bankroll_rue_salv_1 -= bet_amount
                                        bet_team = "away"
                                        does_bet = True
                                        odds = odds_away
                                        count_rue_salv += 1
                                        rue_salv_bets_1.append(
                                            [time_odds[3], time,bet_team, 2 == answer.index(1), bet_amount,odds])
                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if bet_amount > 0:
                                bets_rue_salv_1 += bet_amount
                            print("rue_salv_1: " + str(bet_amount) + " on " + bet_team + "(",unit_set,"). With Odds: "+str(odds)+"---->", bankroll_rue_salv_1)
                            if j+1 == len(data):
                                for o in rue_salv_bets_1:
                                    if o[3]:
                                        bankroll_rue_salv_1 += o[-2] * o[-1]
                        elif system == "rue_salv_2":
                            percent_home = 1 / (2 * odds_home * (1 - value[0].item()))
                            percent_none = 1 / (2 * odds_none * (1 - value[1].item()))
                            percent_away = 1 / (2 * odds_away * (1 - value[2].item()))
                            unit_set = [value[0].item(), value[1].item(), value[2].item()]
                            bet_home = 0
                            bet_none = 0
                            bet_away = 0
                            if bankroll_rue_salv_2 != 0:
                                if unit_set.index(max(unit_set)) == 0 \
                                        and (odds_home * value[0].item() - 1) > 0 \
                                        and odds_home > 1:

                                    bet_home = unit * percent_home
                                    found = False
                                    other_bets = 0
                                    total_betted = 0
                                    for b in rue_salv_bets_2:
                                        if b[2] != "home":
                                            other_bets += b[-2]
                                        if b[2] == "home":
                                            total_betted += b[-2]
                                            found = True
                                    if rue_salv_bets_2 and found:
                                        if rue_salv_bets_2[-1][2] != "home":
                                            if bet_home < total_betted:
                                                bet_amount = other_bets / odds_home
                                            else:
                                                bet_amount = bet_home - total_betted + other_bets / odds_home
                                        elif bet_home > total_betted:
                                            bet_amount = bet_home - total_betted
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "home"
                                            does_bet = True
                                            odds = odds_home
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time, bet_team,0 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        bet_amount = bet_home + other_bets / odds_home
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "home"
                                            does_bet = True
                                            odds = odds_home
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time, bet_team,0 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 1 \
                                        and (odds_none * value[1].item() - 1) > 0 \
                                        and odds_none > 1:
                                    bet_none = unit * percent_none
                                    found = False
                                    other_bets = 0
                                    total_betted = 0
                                    for b in rue_salv_bets_2:
                                        if b[2] != "none":
                                            other_bets += b[-2]
                                        if b[2] == "none":
                                            total_betted += b[-2]
                                            found = True
                                    if rue_salv_bets_2 and found:
                                        if rue_salv_bets_2[-1][2] != "none":
                                            if bet_none < total_betted:
                                                bet_amount = other_bets / odds_none
                                            else:
                                                bet_amount = bet_none - total_betted + other_bets / odds_none
                                        elif bet_none > total_betted:
                                            bet_amount = bet_none - total_betted
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "none"
                                            does_bet = True
                                            odds = odds_none
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time,bet_team,1 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        bet_amount = bet_none + other_bets / odds_none
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "none"
                                            does_bet = True
                                            odds = odds_none
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time,bet_team, 1 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == 2 \
                                        and (odds_away * value[2].item() - 1) > 0 \
                                        and odds_away > 1:
                                    bet_away = unit * percent_away
                                    found = False
                                    other_bets = 0
                                    total_betted = 0
                                    for b in rue_salv_bets_2:
                                        if b[2] != "away":
                                            other_bets += b[-2]
                                        if b[2] == "away":
                                            total_betted += b[-2]
                                            found = True
                                    if rue_salv_bets_2 and found and (bet_away - total_betted) > 0:
                                        if rue_salv_bets_2[-1][2] != "away":
                                            if bet_away < total_betted:
                                                bet_amount = other_bets / odds_away
                                            else:
                                                bet_amount = bet_away - total_betted + other_bets / odds_away
                                        elif bet_away > total_betted:
                                            bet_amount = bet_away - total_betted
                                            if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                                bankroll_rue_salv_2 -= bet_amount
                                                bet_team = "away"
                                                does_bet = True
                                                odds = odds_away
                                                count_rue_salv += 1
                                                rue_salv_bets_2.append(
                                                    [time_odds[3], time, bet_team,2 == answer.index(1), bet_amount,odds])
                                    if not found:
                                        bet_amount = bet_away - other_bets / odds_away
                                        if bankroll_rue_salv_2 >= bet_amount and int(bankroll_rue_salv_2) > 0 and bet_amount > 0:
                                            bankroll_rue_salv_2 -= bet_amount
                                            bet_team = "away"
                                            does_bet = True
                                            odds = odds_away
                                            count_rue_salv += 1
                                            rue_salv_bets_2.append(
                                                [time_odds[3], time,bet_team,2 == answer.index(1), bet_amount,odds])

                                if unit_set.index(max(unit_set)) == answer.index(1) and does_bet:
                                    wins += 1
                            if bet_amount >0:
                                bets_rue_salv_2 += bet_amount
                            if bankroll_kelly_1 < 1:
                                bankroll_kelly_1 = 0
                            if bankroll_kelly_2 < 1:
                                bankroll_kelly_2 = 0
                            if bankroll_rue_salv_1 < 1:
                                bankroll_rue_salv_1 = 0
                            if bankroll_rue_salv_2 < 1:
                                bankroll_rue_salv_2 = 0

                            print("rue_salv_2: " + str(bet_amount) + " on " + bet_team + "(",unit_set,"). With Odds: "+str(odds)+"---->", bankroll_rue_salv_2)
                            if j+1 == len(data):
                                for o in rue_salv_bets_2:
                                    if o[3]:
                                        bankroll_rue_salv_2 += o[-2] * o[-1]
                    does_bet = True
                print("\n")
            bankroll_values.append([bankroll_kelly_1,bankroll_kelly_2,bankroll_rue_salv_1,bankroll_rue_salv_2])

        bankroll_total_values.append(bankroll_values)
        total_bets.append([bets_kelly_1, bets_kelly_2, bets_rue_salv_1, bets_rue_salv_2])


    label = []
    system_id = [0,1,2,3]
    best_roi = None
    print(total_bets)
    for j in range(len(bankroll_values)):
        label.append(j)

    for s in system_id:
        avrg_bankroll = []
        ROIs = []
        for l,bankroll in enumerate(bankroll_total_values):
            ROIs.append(((bankroll[-1][s] - 100) / total_bets[l][s]) * 100)

        best_roi = ROIs.index(max(ROIs))
        worst_roi = ROIs.index(min(ROIs))
        for p in label:
            avrg = 0
            for roll in bankroll_total_values:
                avrg = avrg + roll[p][s]
            avrg_bankroll.append(avrg/len(bankroll_total_values))



        average_roi_value = sum(ROIs)/len(ROIs)
        name = None
        if s == 0:
            name = "Kelly"
        elif s == 1:
            name = "Kelly 2"
        elif s == 2:
            name = "variance-adjusted"
        elif s == 3:
            name = "variance-adjusted 2"
        print("\n "+name)
        print("Best ROI: " +str(max(ROIs))+" on run nr: "+ str(best_roi))
        print("Worst ROI: " +str(min(ROIs))+" on run nr: "+ str(worst_roi))
        print("Average ROI: " + str(average_roi_value))

        plt.figure()
        plt.xlabel("Match")
        plt.ylabel("Bankroll")



        hold_value = [x[s] if x else None for x in bankroll_total_values[best_roi]]
        worst_hold_value = [x[s] if x else None for x in bankroll_total_values[worst_roi]]

        plt.plot(label, worst_hold_value, 'r-', label='Min')
        plt.plot(label, hold_value, 'g-', label='Max')
        plt.plot(label, avrg_bankroll, 'y-', label='Avg')
        plt.axhline(y=100, color='k', linestyle='-')
        plt.legend(loc=0, ncol=2)
        plt.title("Case " + str(case) + " - Continuous betting with regular " + name)
        plt.show()
def closest_time_check(data,bet_min):
    correct_time = None
    min_time = None
    if bet_min == "random":
        min_time = random.randint(1, 90)
    else:
        min_time = bet_min
    for n, w in enumerate(data):
        time = min_time - w[0]
        if time >= 0:
            correct_time = n
        else:
            break
    return correct_time
def calibration(rootdir_test,case = 1): #Calibration method used in 5.1 Calibration
    a = [ 0.0,0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8,0.9,1.0]
    for per in a:
        average = 0
        for i in range(5):
            model = torch.load("models/case_"+str(case)+"_nr_"+str(i))
            model.eval()
            rootdir = rootdir_test
            x = []
            time_sets = []
            y = []
            dataset = split_set(divider=0, path=rootdir, case=case)
            if case == 4 or case == 5 or case == 6:
                filter_matches = dataset.case_4_5_6_test
            else:
                filter_matches = dataset.case_1_2_3_test
            for files in os.walk(rootdir):
                for file in files[2]:
                    label = []
                    if file.split(".")[0] in filter_matches:  # checks if xxxxx.csv is in games
                        with open(rootdir.split("/")[5] + "/" + file, 'rU') as csvfile:
                            reader = csvv.reader(csvfile, delimiter=',')
                            action = list(reader)
                        hold = []
                        hold_time = []
                        for i in action:
                            if i[-2] == "home":
                                label.append([float(1), float(0), float(0)])
                            elif i[-2] == "away":
                                label.append([float(0), float(0), float(1)])
                            else:
                                label.append([float(0), float(1), float(0)])
                            del i[-2]
                            time = i[-1]
                            del i[-1]
                            set = [float(j) for j in i]

                            if case == 1 or case == 4:
                                set = set[0:]
                            if case == 2 or case == 5:
                                set = set[:5]
                            if case == 3 or case == 6:
                                set = [set[0]] + set[5:]

                            hold_time.append(time)
                            hold.append(set)
                        time_sets.append(hold_time)
                        x.append(hold)
                        y.append(label)
            count_avg = 0
            correct = 0
            for i,pre in enumerate(x): # find average probability of the given interval (use to define the range in the next loop)
                output, hidden = model(torch.tensor(pre))
                for j, (s, p) in enumerate(zip(output,pre)):
                    value = s.data
                    answer = y[i][j]
                    if per-0.05 < value[0].item() < per+0.04:
                        if answer.index(1) == 0:
                            correct += 1
                        count_avg += 1
                    if per-0.05 < value[1].item() < per+0.04:
                        if answer.index(1) == 1:
                            correct += 1
                        count_avg += 1
                    if per-0.05 < value[2].item() < per+0.04:
                        if answer.index(1) == 2:
                            correct += 1
                        count_avg += 1
            if count_avg == 0:
                average = 0
            else:
                average +=correct/count_avg

        if average == 0:
            print(per, "none")
        else:
            print(per, average/5, count_avg)

def print_set(input, output, label):
    xg_home = 0
    xg_away = 0
    for i,data in enumerate(input.data.numpy()):
        print(data, end=" ")
        if i == 2:
            xg_away = data
        if i == 1:
            xg_home = data
    print(output.numpy(), end=" ")
    print(label.numpy())
def find_best_network_parameters(path, diff_sets = 3, case=1): # Calculates the accuracy for the RNN based on the case
    layers = [2,4,6]
    units = [32,64,128,256,512]
    l_rate = [0.003, 0.002, 0.001]


    hold_models = []
    dataset = split_set(divider=0, path=path, case=case)
    for i in range(diff_sets):
        acc_list = []
        name_list = []
        dataset.execute()
        for layer in layers:
            for unit in units:
                for l_rat in l_rate:
                    model, acc = train(dataset,50,crit="CE",lstm_layer=layer,hidden_size=unit, l_rate=l_rat, opt="adam")
                    print("unit:"+str(unit)+"layer:"+str(layer)+"l_rate:"+str(l_rat)+" ----", acc)
                    acc_list.append(acc)
                    name_list.append("unit:"+str(unit)+" layer:"+str(layer)+" l_rate:"+str(l_rat))
        hold_models.append([acc_list,name_list])
    avg_acc_name = []
    for sdf,fg in enumerate(hold_models[0][0]):
        avg_acc_name.append([(hold_models[0][0][sdf] + hold_models[1][0][sdf] + hold_models[2][0][sdf])/3,hold_models[0][1][sdf]])
    avg_acc_name = sorted(avg_acc_name,key= lambda x: x[0], reverse=True)
    for i in avg_acc_name:
        print(i)
def betting_sim_1(rootdir_test, rootdir_train): # Betting simulation 1
    betting_simulation(rootdir_test, rootdir_train, shuffle=False, bet_min="random", case=1, train_model=False,
                       baseline=False)
def betting_sim_2(rootdir_test, rootdir_train): # Betting simulation 2
    times = [15,30,45,60,75,90]
    for time in times:
        betting_simulation(rootdir_test, rootdir_train, shuffle=False, bet_min=time, case=1, train_model=False,
                           baseline=False)

#Change rootdir_train and rootdir_test in order to get right pathing
rootdir_train = "C:/Users/kim_1/Desktop/master/case_train"
rootdir_test = "C:/Users/kim_1/Desktop/master/case_test"

find_best_network_parameters(rootdir_train, diff_sets=3, case=1)
betting_sim_1(rootdir_test,rootdir_train)
betting_sim_2(rootdir_test,rootdir_train)
betting_sim_3(rootdir_test, shuffle=False, case=1)